//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by Measurement Studio.
//     Runtime Version:2.0.50727.832
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace NationalInstruments.ModularInstruments.Interop
{
    using System;
    using System.Runtime.InteropServices;


    public class nidcpower : object, System.IDisposable
    {

        private System.IntPtr _handle;

        private bool _disposed = true;

        ~nidcpower() { Dispose(false); }


        /// <summary>
        /// 
        /// 
        /// niDCPower_init
        /// 
        ///  ViStatus niDCPower_init (ViRsrc resourceName, ViBoolean IDQuery,
        ///                                ViBoolean resetDevice,
        ///                                ViSession vi);
        ///  Purpose
        /// Creates a new IVI instrument driver session to the device specified
        ///       in resourceName and returns a session handle you use to identify the
        ///       device in all subsequent NI-DCPower function calls. This function
        ///       also sends initialization commands to set the device to the state
        ///       necessary for the operation of NI-DCPower. 
        /// 	  
        /// To place the device in a known start-up state when creating a new session, set resetDevice to VI_TRUE. This action is equivalent to using the niDCPower_reset function.
        /// 
        /// To open a session and leave the device in its existing configuration without passing through a transitional output state, set resetDevice to VI_FALSE, and immediately call the niDCPower_Abort function. To apply a new configuration without disrupting the output channels of the device, configure the device in Delayed Configuration mode as in the previous session changing only the desired settings, and then call niDCPower_Initiate function.
        /// 
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// 
        /// 
        ///  resourceName
        /// ViRsrc
        /// Specifies the resourceName assigned by Measurement &amp; Automation
        ///           Explorer (MAX), for example &quot;PXI1Slot3&quot; where &quot;PXI1Slot3&quot; is an
        ///           instrument's resourceName. resourceName can also be a logical IVI
        ///           name.
        /// 
        /// </param>
        /// <param name="ID_Query">
        /// 
        ///  IDQuery
        /// ViBoolean
        /// Specifies whether the device is queried to determine if the device is a valid instrument for NI-DCPower.
        /// 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// VI_TRUE (1) Perform ID query.VI_FALSE (0)Do not perform ID query.
        /// 
        /// Default Value: VI_TRUE
        /// 
        /// 
        /// </param>
        /// <param name="Reset_Device">
        ///  
        ///  resetDevice
        /// ViBoolean
        /// Specifies whether to reset the device during the initialization procedure.
        /// 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// VI_TRUE (1) Reset the device.VI_FALSE (0)Do not reset the device.
        /// 
        /// Default Value: VI_TRUE
        /// 
        /// 
        /// </param>
        /// <param name="Instrument_Handle">
        /// 
        ///  vi
        /// ViSession
        /// Returns a session handle that you use to identify the session in all subsequent NI-DCPower function calls.
        /// 
        /// </param>
        public nidcpower(string Resource_Name, bool ID_Query, bool Reset_Device)
        {
            int pInvokeResult = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }

        /// <summary>
        /// 
        /// niDCPower_InitExtCal
        /// 
        /// 
        ///  ViStatus niDCPower_InitExtCal (ViRsrc resourceName,
        ///                                      ViConstString password,
        ///                                      ViSession *newVi);
        ///  Purpose
        /// If password is valid, this function creates a new IVI instrument driver
        ///       session to the device specified in resourceName and returns an
        ///       instrument handle you use to identify the device in all subsequent
        ///       NI-DCPower function calls. This function also sends initialization
        ///       commands to set the device to the state necessary for the operation
        ///       of NI-DCPower.
        ///       
        ///       Opening a calibration session always performs a reset. Refer to the calibration procedure for the device 
        ///   you are calibrating for detailed instructions on the appropriate use of this function.
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// 
        ///  resourceName
        /// ViRsrc
        /// Specifies the resourceName assigned by Measurement &amp; Automation
        ///           Explorer (MAX), for example &quot;PXI1Slot3&quot; where &quot;PXI1Slot3&quot; is an
        ///           instrument's resourceName. resourceName can also be a logical IVI
        ///           name.     
        /// 
        /// </param>
        /// <param name="Password">
        /// 
        ///  password
        /// ViConstString
        /// Specifies the password for opening a calibration session. The initial password is factory configured to "NI".  password can be a maximum of four alphanumeric characters.
        /// 
        /// </param>
        /// <param name="Instrument_Handle">
        ///  
        /// 
        ///  newVi
        /// ViSession*
        /// Returns a handle that you use to identify the session in all subsequent NI-DCPower function calls.
        /// 
        /// </param>
        public nidcpower(string Resource_Name, string Password)
        {
            int pInvokeResult = PInvoke.InitExtCal(Resource_Name, Password, out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }

        /// <summary>
        /// 
        /// niDCPower_InitWithOptions
        /// 
        ///  ViStatus niDCPower_InitWithOptions (ViRsrc resourceName,
        ///                                           ViBoolean IDQuery,
        ///                                           ViBoolean resetDevice,
        ///                                           ViString optionString,
        ///                                           ViSession *newVi);
        ///  Purpose
        /// Creates a new IVI instrument driver session to the device specified in resourceName and returns a session handle you use to identify the device in all subsequent NI-DCPower function calls. With this function, you can optionally set the initial state of the following session attributes: 
        ///  NIDCPOWER_ATTR_SIMULATE
        ///   NIDCPOWER_ATTR_DRIVER_SETUP
        ///   NIDCPOWER_ATTR_RANGE_CHECK
        ///   NIDCPOWER_ATTR_QUERY_INSTRUMENT_STATUS
        ///  NIDCPOWER_ATTR_CACHE
        ///   NIDCPOWER_ATTR_RECORD_COERCIONS
        /// 
        /// 
        /// This function also sends initialization commands to set the device to the state necessary for NI-DCPower to operate.
        /// 
        /// To place the device in a known start-up state when creating a new session, set resetDevice to VI_TRUE. This action is equivalent to using the niDCPower_reset function.
        /// 
        /// To open a session and leave the device in its existing configuration without passing through a transitional output state, set resetDevice to VI_FALSE, and immediately call the niDCPower_Abort function. To apply a new configuration without disrupting the output channels of the device, configure the device in Delayed Configuration mode as in the previous session changing only the desired settings, and then call the niDCPower_Initiate function.
        /// 
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// 
        ///  resourceName
        /// ViRsrc
        /// Specifies the resourceName assigned by Measurement &amp; Automation Explorer (MAX), for example &quot;PXI1Slot3&quot; where &quot;PXI1Slot3&quot; is an instrument's resourceName. resourceName can also be a logical IVI name.
        /// 
        /// </param>
        /// <param name="ID_Query">
        /// 
        ///  IDQuery
        /// ViBoolean
        /// Specifies whether the device is queried to determine if the device is a valid instrument for NI-DCPower. The default value is VI_TRUE.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Reset_Device">
        /// 
        ///  resetDevice
        /// ViBoolean
        /// Specifies whether to reset the device during the initialization procedure. The default value is VI_TRUE.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Option_String">
        /// 
        ///  optionString
        /// ViString
        /// Specifies the initial value of certain attributes for the session. The syntax for optionString is a list of attributes with an assigned value where 1 is VI_TRUE and 0 is VI_FALSE. Each attribute/value combination is delimited with a comma, as shown in the following example: 
        /// &quot;Simulate=0,RangeCheck=1,QueryInstrStatus=0,Cache=1&quot;If you do not wire this input or pass an empty string, the session assigns the default values, shown in the example, for these attributes. You do not have to specify a value for all the attributes. If you do not specify a value for an attribute, the default value is used. 
        /// 
        /// For more information about simulating a device, refer to  Simulating a Power Supply or SMU. 
        /// 
        /// </param>
        /// <param name="Instrument_Handle">
        /// 
        ///  newVi
        /// ViSession*
        /// Returns a handle that you use to identify the device in all subsequent NI-DCPower function calls.
        /// 
        /// </param>
        public nidcpower(string Resource_Name, bool ID_Query, bool Reset_Device, string Option_String)
        {
            int pInvokeResult = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Option_String, out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ConfigureOutputEnabled
        /// 
        /// 
        ///  ViStatus niDCPower_ConfigureOutputEnabled (ViSession vi,
        ///                                                  ViConstString channelName,
        ///                                                  ViBoolean enabled);
        ///  Purpose
        /// Enables or disables generation on the specified  channel(s).  Depending on the selected output function, the voltage level or the current level must be set in addition to enabling the output to generate the desired level.  Refer to the niDCPower_ConfigureVoltageLevel function, the niDCPower_ConfigureCurrentLevel function, and the niDCPower_ConfigureOutputFunction function for more information about configuring the desired output level.
        /// 
        /// 
        /// Note&#160;&#160;If the device is in Delayed Configuration mode, enabling the output will not take effect until you call the niDCPower_Initiate function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple 
        /// channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). 
        /// A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, 
        /// multiple output channel configurations are performed sequentially based on the order specified in this parameter. 
        /// 
        /// </param>
        /// <param name="Enabled">
        /// 
        ///  enabled
        /// ViBoolean
        /// Specifies whether the output is enabled or disabled.
        /// 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// VI_TRUEEnables generation on the specified output channel(s).
        /// VI_FALSEDisables generation on the specified output channel(s).
        /// 
        /// 
        /// 
        /// Default Value: VI_TRUE
        /// </param>
        public int ConfigureOutputEnabled(string Channel_Name, bool Enabled)
        {
            int pInvokeResult = PInvoke.ConfigureOutputEnabled(this._handle, Channel_Name, System.Convert.ToUInt16(Enabled));
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_ConfigureOutputFunction
        /// 
        /// 
        ///  ViStatus niDCPower_ConfigureOutputFunction (ViSession vi,
        ///                                                  ViConstString channelName,
        ///                                                  ViBoolean function);
        ///  Purpose
        /// Configures the function the device attempts to generate for the specified channel(s).
        /// 
        /// 
        /// When NIDCPOWER_VAL_DC_VOLTAGE is selected, the device generates the desired voltage level on the output as long as the output current is below the current limit. The following functions can be used to configure the channel when NIDCPOWER_VAL_DC_VOLTAGE is selected:
        /// niDCPower_ConfigureVoltageLevel
        /// niDCPower_ConfigureCurrentLimit
        /// 
        /// niDCPower_ConfigureVoltageLevelRange
        /// 
        /// niDCPower_ConfigureCurrentLimitRange
        /// 
        /// When NIDCPOWER_VAL_DC_CURRENT is selected, the device generates the desired current level on the output as long as the output voltage is below the voltage limit.  The following functions can be used to configure the channel when NIDCPOWER_VAL_DC_CURRENT is selected:
        /// niDCPower_ConfigureCurrentLevel
        /// 
        /// niDCPower_ConfigureVoltageLimit
        /// 
        /// niDCPower_ConfigureCurrentLevelRange
        /// 
        /// niDCPower_ConfigureVoltageLimitRange
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple 
        /// channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). 
        /// A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, 
        /// multiple output channel configurations are performed sequentially based on the order specified in this parameter. 
        /// 
        /// </param>
        /// <param name="Function">
        /// 
        ///  function
        /// ViInt32
        /// Configures the function to generate for the specified channel(s).
        /// 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// NIDCPOWER_VAL_DC_VOLTAGESets the output function to DC voltage.
        /// NIDCPOWER_VAL_DC_CURRENTSets the output function to DC current.
        /// 
        /// 
        /// Default Value: NIDCPOWER_VAL_DC_VOLTAGE
        /// 
        /// 
        /// 
        /// </param>
        public int ConfigureOutputFunction(string Channel_Name, int Function)
        {
            int pInvokeResult = PInvoke.ConfigureOutputFunction(this._handle, Channel_Name, Function);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_MeasureMultiple
        /// 
        /// 
        ///  ViStatus niDCPower_MeasureMultiple (ViSession vi,
        ///                                               ViConstString channelName,
        ///                                               ViReal64 voltageMeasurements[],
        ///                                               ViReal64 currentMeasurements[]);
        ///  Purpose
        /// Returns arrays of the measured voltage and current values
        ///       on the specified output channel(s). Each call to this function
        ///       blocks other function calls until the measurements are returned from the
        ///       device. The order of the measurements returned in the array corresponds to the
        ///       order on the specified output channel(s). The measurement speed of the device and the NIDCPOWER_ATTR_SAMPLES_TO_AVERAGE attribute
        ///   dictates the length of time that a measurement takes.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies the output channels to measure. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2).
        /// 
        /// </param>
        /// <param name="Voltage_Measurements">
        /// 
        ///  voltageMeasurements
        /// ViReal64[]
        /// Returns an array of voltage measurements. The measurements in the array are returned in the same order as the channels specified in channelName. Ensure that sufficient space has been allocated for the returned array.
        /// 
        /// </param>
        /// <param name="Current_Measurements">
        /// 
        ///  currentMeasurements
        /// ViReal64[]
        /// Returns an array of current measurements. The measurements in the array are returned in the same order as the channels specified in channelName. Ensure that sufficient space has been allocated for the returned array.
        /// 
        /// </param>
        public int MeasureMultiple(string Channel_Name, double[] Voltage_Measurements, double[] Current_Measurements)
        {
            int pInvokeResult = PInvoke.MeasureMultiple(this._handle, Channel_Name, Voltage_Measurements, Current_Measurements);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ConfigureSense
        /// 
        /// 
        ///  ViStatus niDCPower_ConfigureSense (ViSession vi,
        ///                                                  ViConstString channelName,
        ///                                                  ViBoolean sense);
        ///  Purpose
        /// Specifies whether to use local or remote sensing of the output voltage on the specified channel(s).  Refer to the Devices topic specific to your device in the NI DC Power Supplies and SMUs Help to find out more information about sensing on supported channels.  
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple 
        /// channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). 
        /// A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, 
        /// multiple output channel configurations are performed sequentially based on the order specified in this parameter. 
        /// 
        /// </param>
        /// <param name="Sense">
        /// 
        /// 
        ///  sense
        /// ViInt32
        ///  Specifies local or remote sensing on the specified channel(s).
        /// 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// NIDCPOWER_VAL_LOCALLocal sensing NIDCPOWER_VAL_REMOTERemote sensing
        /// 
        /// 
        /// 
        /// Default Value: NIDCPOWER_VAL_LOCAL
        /// 
        /// </param>
        public int ConfigureSense(string Channel_Name, int Sense)
        {
            int pInvokeResult = PInvoke.ConfigureSense(this._handle, Channel_Name, Sense);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_Initiate
        /// 
        /// 
        ///  ViStatus niDCPower_Initiate (ViSession vi);
        ///  Purpose
        /// Commits the configured settings to hardware and places the device in
        ///        Immediate mode. Any configuration calls made after this function are applied immediately. To commit simultaneous hardware settings on
        ///       multiple output channels, call the niDCPower_Abort function, configure the power
        ///       supply, and call this function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        public int Initiate()
        {
            int pInvokeResult = PInvoke.Initiate(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_Abort
        /// 
        /// 
        ///  ViStatus niDCPower_Abort (ViSession vi);
        ///  Purpose
        /// Places the device in  Delayed Configuration mode. Any
        ///       configuration functions called after this function are not
        ///       applied until the niDCPower_Initiate function is called. If power output
        ///       is enabled when you call the niDCPower_Abort function, the output channels remain
        ///       in their current state and continue providing power.Use the niDCPower_ConfigureOutputEnabled function to disable power output
        ///       on a per channel basis. Use the niDCPower_reset function to disable
        ///       output on all channels. While in Delayed Configuration mode, NI-DCPower performs only generic parameter validation. Any conflicting configuration calls
        ///       are not validated until the niDCPower_Initiate function is called. If the
        ///       same configuration is set multiple times to different values, NI-DCPower uses the last configuration call.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        public int Abort()
        {
            int pInvokeResult = PInvoke.Abort(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ConfigureVoltageLevel
        /// 
        /// 
        ///  ViStatus niDCPower_ConfigureVoltageLevel (ViSession vi,
        ///                                                 ViConstString channelName,
        ///                                                 ViReal64 level);
        ///  Purpose
        /// Configures the voltage level the device attempts to generate for the specified channel(s). The channel must be enabled for the specified voltage level to take effect.  Refer to the niDCPower_ConfigureOutputEnabled attribute for more information about enabling the output channel.
        /// 
        /// 
        /// The voltage level setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_VOLTAGE output function using the niDCPower_ConfigureOutputFunction function.  The device actively regulates the voltage at the specified level unless doing so causes a current output greater than the current limit through the channels' output terminals.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        /// of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        /// 
        /// </param>
        /// <param name="Level">
        /// 
        ///  level
        /// ViReal64
        ///  Specifies the voltage level, in volts, for the output channel generation. 
        /// 
        /// 
        /// 
        /// 
        /// Valid Values:
        /// 
        /// The valid values for this parameter are defined by the voltage level range that is selected using the niDCPower_ConfigureVoltageLevelRange function.
        /// 
        /// </param>
        public int ConfigureVoltageLevel(string Channel_Name, double Level)
        {
            int pInvokeResult = PInvoke.ConfigureVoltageLevel(this._handle, Channel_Name, Level);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ConfigureVoltageLevelRange
        /// 
        /// 
        ///  ViStatus niDCPower_ConfigureVoltageLevel Range(ViSession vi,
        ///                                                 ViConstString channelName,
        ///                                                 ViReal64 range);
        ///  Purpose
        /// Configures the voltage level range for the specified channel(s).  The configured range defines the valid values the voltage level can be set to using the niDCPower_ConfigureVoltageLevel function.  
        /// 
        /// The voltage level range setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_VOLTAGE output function using the niDCPower_ConfigureOutputFunction function. 
        ///      
        /// Use the NIDCPOWER_ATTR_VOLTAGE_LEVEL_AUTORANGE attribute to enable automatic selection of the voltage level range. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        /// of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        ///  range
        /// ViReal64
        /// Specifies the voltage level range, in volts, on the specified channel(s).
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Valid Values:
        /// 
        /// 
        /// NI PXI-4110
        /// ChannelVoltage Level Range (V)Voltage Level (V)
        /// 060 to +6
        /// 1200 to +20
        /// 2200 to -20
        /// 
        /// 
        /// NI PXI-4130
        /// 
        /// ChannelVoltage Level Range (V)Voltage Level (V)
        /// 060 to +6
        /// 16-6 to +6
        /// 20-20 to +20
        /// 
        /// Note&#160;&#160;  If a range other than what is listed in the preceding table is selected, it will be coerced to the next-highest range.  For example, requesting the 10 V voltage level range on Channel 1 on the NI-PXI 4130 coerces the voltage level range to 20 V.  Refer to the Ranges topic in the NI DC Power Supplies and SMUs Help for more information about coercion.
        /// 
        /// 
        /// 
        /// 
        /// </param>
        public int ConfigureVoltageLevelRange(string Channel_Name, double Range)
        {
            int pInvokeResult = PInvoke.ConfigureVoltageLevelRange(this._handle, Channel_Name, Range);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ConfigureCurrentLimit
        /// 
        /// 
        ///  ViStatus niDCPower_ConfigureCurrentLimit (ViSession vi,
        ///                                                 ViConstString channelName,
        ///                                                 ViInt32 behavior,
        ///                                                 ViReal64 limit);
        ///  Purpose
        /// Configures the current limit for the specified channel(s).
        ///       The channel must be enabled for the specified current limit to take effect. Refer to
        ///       the niDCPower_ConfigureOutputEnabled function for more information about enabling the output channel.
        /// 
        /// 
        /// 
        /// The current limit is the current that the output should not exceed when generating the desired voltage level.  The current limit setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_VOLTAGE output function using the niDCPower_ConfigureOutputFunction function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify 
        /// multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        /// of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a 
        /// hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this 
        /// parameter.
        /// 
        /// </param>
        /// <param name="Behavior">
        /// 
        ///  behavior
        /// ViInt32
        /// Specifies how the output should behave when the current limit is
        ///           reached.
        /// 
        /// 
        ///           Defined Values:
        /// 
        ///           NIDCPOWER_VAL_CURRENT_REGULATEControls output current so that it does not exceed the current limit.  Power continues to generate even if the current limit is reached.
        ///           
        ///           
        /// 
        /// </param>
        /// <param name="Limit">
        /// 
        ///  limit
        /// ViReal64
        /// Specifies the current limit, in amps, on the specified channel(s).
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Valid Values:
        /// 
        /// The valid values for this parameter are defined by the current limit range that is configured using the niDCPower_ConfigureCurrentLimitRange function.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        public int ConfigureCurrentLimit(string Channel_Name, int Behavior, double Limit)
        {
            int pInvokeResult = PInvoke.ConfigureCurrentLimit(this._handle, Channel_Name, Behavior, Limit);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ConfigureCurrentLimitRange
        /// 
        /// 
        ///  ViStatus niDCPower_ConfigureCurrentLimit Range(ViSession vi,
        ///                                                 ViConstString channelName,
        ///                                                 ViReal64 range);
        ///  Purpose
        /// Configures the current limit range for the specified 
        ///       channel(s).The configured range defines the valid values  the current limit can be set to using the niDCPower_ConfigureCurrentLimit function. The current limit range setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_VOLTAGE output function using the niDCPower_ConfigureOutputFunction function. 
        /// Use the NIDCPOWER_ATTR_CURRENT_LIMIT_AUTORANGE attribute to enable automatic selection of the current limit range.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        /// of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        ///  range
        /// ViReal64
        /// Specifies the current limit range, in amps, for the specified channel.
        /// 
        /// 
        /// 
        /// Valid Values:
        /// 
        /// 
        /// NI PXI-4110
        /// ChannelCurrent Limit RangeCurrent Limit
        /// 01 A+0.01 to +1 A
        /// 1, 220 mA+0.20 to +20 mA
        /// 1 A+0.01 to +1 A
        /// 
        /// 
        /// NI PXI-4130
        /// ChannelCurrent Limit RangeCurrent Limit
        /// 01 A+0.02 to +1 A
        /// 1200 &#956;A +4 to +200 &#956;A
        /// 2 mA+0.04 to +2 mA
        /// 20 mA+0.40 to +20 mA
        /// 200 mA+4 to +200 mA
        /// 2 A+0.04 to +2 A
        /// 
        /// 
        /// Note&#160;&#160;  If a range other than what is listed in the preceding table is selected, it will be coerced to the next-highest range.  For example, requesting the 100 mA current limit range on Channel 1 on the NI-PXI 4130 coerces the current level range to 200 mA.  Refer to the Ranges topic in the NI DC Power Supplies and SMUs Help for more information about coercion.
        /// 
        /// 
        /// 
        /// 
        /// </param>
        public int ConfigureCurrentLimitRange(string Channel_Name, double Range)
        {
            int pInvokeResult = PInvoke.ConfigureCurrentLimitRange(this._handle, Channel_Name, Range);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ConfigureCurrentLevel
        /// 
        /// 
        ///  ViStatus niDCPower_ConfigureCurrentLevel (ViSession vi,
        ///                                                 ViConstString channelName,
        ///                                                 ViReal64 level);
        ///  Purpose
        /// Configures the current level the device attempts to generate for the specified 
        ///       channel(s). The channel must be enabled for the specified current level to take effect.  Refer to the niDCPower_ConfigureOutputEnabled function for more information about enabling the output channel.  
        /// 
        /// The current level setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_CURRENT output function using the niDCPower_ConfigureOutputFunction function.  The device actively regulates the current at the specified level unless doing so causes a voltage greater than the voltage limit across the channels' output terminals.
        ///     
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        /// of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        /// 
        /// </param>
        /// <param name="Level">
        /// 
        ///  level
        /// ViReal64
        /// Specifies the current level, in amps, to generate for the specified channel(s).
        /// 
        /// 
        /// 
        /// 
        /// Valid Values:
        /// 
        /// The valid values for this parameter are defined by the current level range that is configured using the niDCPower_ConfigureCurrentLevelRange function.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        public int ConfigureCurrentLevel(string Channel_Name, double Level)
        {
            int pInvokeResult = PInvoke.ConfigureCurrentLevel(this._handle, Channel_Name, Level);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ConfigureCurrentLevelRange
        /// 
        /// 
        ///  ViStatus niDCPower_ConfigureCurrentLevelRange (ViSession vi,
        ///                                                 ViConstString channelName,
        ///                                                 ViReal64 range);
        ///  Purpose
        /// Configures the current level range for the specified 
        ///       channel(s).  The configured range defines the valid values the current level can be set to using the niDCPower_ConfigureCurrentLevel function.  The current level range setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_CURRENT output function using the niDCPower_ConfigureOutputFunction function. 
        /// 
        /// Use the NIDCPOWER_ATTR_CURRENT_LEVEL_AUTORANGE attribute to enable automatic selection of the current level range. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        /// of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        ///  range
        /// ViReal64
        /// Specifies the current level range, in amps,  for the specified channel.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Valid Values:
        /// 
        /// 
        /// NI PXI-4110
        /// 
        /// ChannelCurrent Level RangeCurrent Level
        /// 01 A+0.01 to +1 A
        /// 120 mA+0.20 to +20 mA
        /// 1 A+0.01 to +1 A
        /// 220 mA-0.20 to -20 mA
        /// 1 A-0.01 to -1 A
        /// 
        /// 
        /// NI PXI-4130
        /// 
        /// ChannelCurrent Level RangeCurrent Level
        /// 01 A+0.02 to +1 A
        /// 1200 &#956;A +4 to +200 &#956;A and -4 to -200 &#956;A
        /// 2 mA+0.04 to +2 mA and -0.04 to -2 mA
        /// 20 mA+0.40 to +20 mA and -0.40 to -20 mA
        /// 200 mA+4 to +200 mA and -4 to -200 mA
        /// 2 A+0.04 to +2 A and -0.04 to -2 A
        /// 
        /// Note&#160;&#160;  If a range other than what is listed in the preceding table is selected, it will be coerced to the next-highest range.  For example, requesting the 100 mA current level range on Channel 1 on the NI-PXI 4130 coerces the current level range to 200 mA.  Refer to the Ranges topic in the NI DC Power Supplies and SMUs Help for more information about coercion.
        /// 
        /// </param>
        public int ConfigureCurrentLevelRange(string Channel_Name, double Range)
        {
            int pInvokeResult = PInvoke.ConfigureCurrentLevelRange(this._handle, Channel_Name, Range);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ConfigureVoltageLimit
        /// 
        /// 
        ///  ViStatus niDCPower_ConfigureVoltageLimit (ViSession vi,
        ///                                                 ViConstString channelName,
        ///                                                 ViReal64 limit);
        ///  Purpose
        /// Configures the voltage limit for the specified channel(s). The channel must be enabled for the specified voltage limit to take effect.
        ///       Refer to the niDCPower_ConfigureOutputEnabled function for more information about enabling the output channel.
        /// 
        /// The voltage limit is the voltage that the output should not exceed when generating the desired current level.   The voltage limit setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_CURRENT output function using the niDCPower_ConfigureOutputFunction function. 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        /// of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        /// 
        /// </param>
        /// <param name="Limit">
        /// 
        ///  limit
        /// ViReal64
        /// Specifies the voltage limit, in volts, on the specified output channel(s).
        /// 
        /// 
        /// 
        /// 
        /// Valid Values:
        /// 
        /// The valid values for this parameter are defined by the voltage limit range that is configured using the  niDCPower_ConfigureVoltageLimitRange function.
        /// 
        /// 
        /// 
        /// 
        /// </param>
        public int ConfigureVoltageLimit(string Channel_Name, double Limit)
        {
            int pInvokeResult = PInvoke.ConfigureVoltageLimit(this._handle, Channel_Name, Limit);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ConfigureVoltageLimitRange
        /// 
        /// 
        ///  ViStatus niDCPower_ConfigureVoltageLimitRange (ViSession vi,
        ///                                                 ViConstString channelName,
        ///                                                 ViReal64 range);
        ///  Purpose
        /// Configures the voltage limit range for the specified
        ///       channel(s). The configured range defines the valid values the voltage limit can be set to using the niDCPower_ConfigureVoltageLimit function.
        ///      The voltage limit range setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_CURRENT output function using the niDCPower_ConfigureOutputFunction function. 
        /// Use the NIDCPOWER_ATTR_VOLTAGE_LIMIT_AUTORANGE attribute to enable automatic selection of the voltage limit range.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        /// of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        ///  range
        /// ViReal64
        /// Specifies the voltage limit range, in volts, on the specified channel(s).
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Valid Values:
        /// 
        /// 
        /// NI PXI-4110
        /// ChannelVoltage Limit Range (V)Voltage Limit (V)
        /// 060 to +6
        /// 1, 2200 to +20
        /// 
        /// 
        /// 
        /// NI PXI-4130
        /// ChannelVoltage Limit Range (V)Voltage Limit (V)
        /// 060 to +6
        /// 160 to +6
        /// 200 to +20
        /// 
        /// 
        /// Note&#160;&#160;  If a range other than what is listed in the preceding table is selected, it will be coerced to the next-highest range.  For example, requesting the 10 V voltage limit range on Channel 1 on the NI-PXI 4130 coerces the voltage limit range to 20 V.  Refer to the Ranges topic in the NI DC Power Supplies and SMUs Help for more information about coercion.
        /// 
        /// 
        /// </param>
        public int ConfigureVoltageLimitRange(string Channel_Name, double Range)
        {
            int pInvokeResult = PInvoke.ConfigureVoltageLimitRange(this._handle, Channel_Name, Range);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        ///  
        /// niDCPower_QueryOutputState
        /// 
        ///  ViStatus niDCPower_QueryOutputState (ViSession vi,
        ///                                            ViConstString channelName,
        ///                                            ViInt32 outputState,
        ///                                            ViBoolean  *inState);
        ///  Purpose
        /// Queries the specified output channel to determine if the output channel is currently in the state specified by outputState.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies the output channel to query.  The output state may only be queried for one channel at a time.
        /// 
        /// </param>
        /// <param name="Output_State">
        ///  
        ///  outputState
        /// ViInt32
        /// Specifies the outputState of the output channel that is being queried.
        /// 
        /// 
        /// Defined Values:
        /// NIDCPOWER_VAL_OUTPUT_CONSTANT_VOLTAGEThe device maintains a constant
        ///           voltage by adjusting the current.
        ///   NIDCPOWER_VAL_OUTPUT_CONSTANT_CURRENTThe device maintains a constant
        ///           current by adjusting the voltage.
        /// 
        /// 
        /// Default Value: NIDCPOWER_VAL_OUTPUT_CONSTANT_VOLTAGE
        /// </param>
        /// <param name="In_State">
        /// 
        ///  inState
        /// ViBoolean*
        /// Returns whether the device output channel is in the specified state.
        /// 
        /// </param>
        public int QueryOutputState(string Channel_Name, int Output_State, out bool In_State)
        {
            ushort In_StateAsUShort;
            int pInvokeResult = PInvoke.QueryOutputState(this._handle, Channel_Name, Output_State, out In_StateAsUShort);
            In_State = System.Convert.ToBoolean(In_StateAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        ///  
        /// niDCPower_QueryInCompliance
        /// 
        ///  ViStatus niDCPower_QueryInCompliance(ViSession vi,
        ///                                            ViConstString channelName,
        ///                                            
        ///                                            ViBoolean *inCompliance);
        ///  Purpose
        /// Queries the device to indicate if the output is operating at the compliance limit.
        /// 
        /// The compliance limit is the current limit when the output function is set to NIDCPOWER_VAL_DC_VOLTAGE.  If the output is operating at the compliance limit, the output reaches the current limit before the desired voltage level.  Refer to the niDCPower_ConfigureOutputFunction function and the niDCPower_ConfigureCurrentLimit function for more information about output function and current limit, respectively.
        /// 
        /// The compliance limit is the voltage limit when the output function is set to NIDCPOWER_VAL_DC_CURRENT.  If the output is operating at the compliance limit, the output reaches the voltage limit before the desired current level.  Refer to the niDCPower_ConfigureOutputFunction function and the niDCPower_ConfigureVoltageLimit function for more information about output function and voltage limit, respectively.
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies the output channel to query. Compliance status can only be queried for one channel at a time.
        /// 
        /// </param>
        /// <param name="In_Compliance">
        /// 
        ///  inCompliance
        /// ViBoolean*
        /// Returns whether the device output channel is in compliance.
        /// 
        /// </param>
        public int QueryInCompliance(string Channel_Name, out bool In_Compliance)
        {
            ushort In_ComplianceAsUShort;
            int pInvokeResult = PInvoke.QueryInCompliance(this._handle, Channel_Name, out In_ComplianceAsUShort);
            In_Compliance = System.Convert.ToBoolean(In_ComplianceAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_Measure
        /// 
        /// 
        ///  ViStatus niDCPower_Measure (ViSession vi,
        ///                                   ViConstString channelName,
        ///                                   ViInt32 measurementType,
        ///                                   ViReal64 *measurement)
        ///  Purpose
        /// Returns the measured value of either the voltage or current on the specified output channel. Each call to this function blocks
        ///       other function calls until the hardware returns the measurement.
        ///       The measurement speed of the device and the NIDCPOWER_ATTR_SAMPLES_TO_AVERAGE
        ///       attribute dictate the length of time that a measurement takes. To measure multiple output channels, use the 
        ///       niDCPower_MeasureMultiple function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies the output channel to measure.  Only one channel can be measured at a time with this function.  Use the niDCPower_MeasureMultiple function to measure multiple channels.
        /// 
        /// </param>
        /// <param name="Measurement_Type">
        /// 
        ///  measurementType
        /// ViInt32
        /// Specifies whether a voltage or current value should be measured.
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// NIDCPOWER_VAL_MEASURE_VOLTAGEThe device measures voltage. NIDCPOWER_VAL_MEASURE_CURRENTThe device measures current.
        /// 
        /// Default Value: NIDCPOWER_VAL_MEASURE_VOLTAGE
        /// 
        /// </param>
        /// <param name="Measurement">
        /// 
        ///  measurement
        /// ViReal64*
        /// Returns the value of the measurement, either in volts for voltage or
        ///           amps for current.
        /// 
        /// </param>
        public int Measure(string Channel_Name, int Measurement_Type, out double Measurement)
        {
            int pInvokeResult = PInvoke.Measure(this._handle, Channel_Name, Measurement_Type, out Measurement);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_QueryMaxCurrentLimit
        /// 
        /// 
        ///  ViStatus niDCPower_QueryMaxCurrentLimit (ViSession vi,
        ///                                                ViConstString channelName,
        ///                                                ViReal64 voltageLevel,
        ///                                                ViReal64 *maxCurrentLimit);
        ///  Purpose
        /// Queries the maximum current limit on an output channel if the output channel is set to the specified voltageLevel.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies the output channel to query.  The maximum current limit may only be queried for one channel at a time.
        /// 
        /// </param>
        /// <param name="Voltage_Level">
        /// 
        ///  voltageLevel
        /// ViReal64
        /// Specifies the voltage level to use when calculating the maxCurrentLimit.
        /// 
        /// </param>
        /// <param name="Max_Current_Limit">
        /// 
        ///  maxCurrentLimit
        /// ViReal64*
        /// Returns the maximum current limit that can be set with the specified
        ///           voltageLevel.
        /// 
        /// </param>
        public int QueryMaxCurrentLimit(string Channel_Name, double Voltage_Level, out double Max_Current_Limit)
        {
            int pInvokeResult = PInvoke.QueryMaxCurrentLimit(this._handle, Channel_Name, Voltage_Level, out Max_Current_Limit);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        ///  
        /// niDCPower_QueryMaxVoltageLevel
        /// 
        /// 
        ///  ViStatus niDCPower_QueryMaxVoltageLevel (ViSession vi,
        ///                                                ViConstString channelName,
        ///                                                ViReal64 currentLimit,
        ///                                                ViReal64 *maxVoltageLevel);
        ///  Purpose
        /// Queries the maximum voltage level on an output channel if the output channel is set to the specified currentLimit.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies the output channel to query.  The maximum voltage level may only be queried for one channel at a time.
        /// 
        /// </param>
        /// <param name="Current_Limit">
        /// 
        ///  currentLimit
        /// ViReal64
        /// Specifies the current limit to use when calculating the maxVoltageLevel.
        /// 
        /// </param>
        /// <param name="Max_Voltage_Level">
        /// 
        ///  maxVoltageLevel
        /// ViReal64*
        /// Returns the maximum voltage level that can be set on an output channel with the specified
        ///           currentLimit.
        /// 
        /// </param>
        public int QueryMaxVoltageLevel(string Channel_Name, double Current_Limit, out double Max_Voltage_Level)
        {
            int pInvokeResult = PInvoke.QueryMaxVoltageLevel(this._handle, Channel_Name, Current_Limit, out Max_Voltage_Level);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_QueryMinCurrentLimit
        /// 
        /// 
        ///  ViStatus niDCPower_QueryMinCurrentLimit (ViSession vi,
        ///                                                ViConstString channelName,
        ///                                                ViReal64 voltageLevel,
        ///                                                ViReal64 *minCurrentLimit);
        ///  Purpose
        /// Queries the minimum current limit on an output channel if the output channel is set to the specified voltageLevel.
        ///
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies the output channel to query. The minimum current limit may only be queried for one channel at a time.
        /// 
        /// </param>
        /// <param name="Voltage_Level">
        /// 
        ///  voltageLevel
        /// ViReal64
        /// Specifies the voltage level to use when calculating the minCurrentLimit.
        /// 
        /// </param>
        /// <param name="Min_Current_Limit">
        /// 
        ///  minCurrentLimit
        /// ViReal64*
        /// Returns the minimum current limit that can be set on an output channel with the specified voltageLevel.
        /// 
        /// </param>
        public int QueryMinCurrentLimit(string Channel_Name, double Voltage_Level, out double Min_Current_Limit)
        {
            int pInvokeResult = PInvoke.QueryMinCurrentLimit(this._handle, Channel_Name, Voltage_Level, out Min_Current_Limit);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_CloseExtCal
        /// 
        /// 
        ///  ViStatus niDCPower_CloseExtCal (ViSession vi,
        ///                                       ViInt32 action);
        ///  Purpose
        /// Closes the session specified in vi and deallocates
        ///       the resources that NI-DCPower reserved for calibration. Refer to the calibration
        ///       procedure for the device you are calibrating for detailed instructions on the
        ///       appropriate use of this function. If an error occurs before this
        ///       function, action defaults to NIDCPOWER_VAL_CANCEL.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        ///  vi
        /// ViSession
        /// Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        /// 
        /// </param>
        /// <param name="Action">
        /// 
        /// 
        ///  action
        /// ViInt32
        /// Specifies how to use the calibration values from this session as the session is closed. 
        /// Defined Values:
        ///           NIDCPOWER_VAL_COMMITThe new calibration constants are stored in the EEPROM.
        ///           NIDCPOWER_VAL_CANCEL The old calibration constants are kept, and the new ones are discarded. 
        /// 
        /// Default Value: NIDCPOWER_VAL_CANCEL
        /// 
        /// </param>
        public int CloseExtCal(int Action)
        {
            int pInvokeResult = PInvoke.CloseExtCal(this._handle, Action);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        ///  niDCPower_CalAdjustVoltageLevel
        /// 
        /// 
        ///  ViStatus niDCPower_CalAdjustVoltageLevel (ViSession vi,
        ///                                                 ViConstString channelName,
        /// 												ViReal64 range,
        ///                                                 ViUInt32 numberOfMeasurements,
        ///                                                 ViReal64 requestedOutputs[],
        ///                                                 ViReal64 measuredOutputs[]);
        ///  Purpose
        /// Calculates the calibration constants for the voltage level for the specified output channel. This function compares the array in
        ///       requestedOutputs to the array in measuredOutputs and calculates the
        ///       calibration constants for the voltage level of the output channel. Refer to the calibration procedure
        ///       of the device you are calibrating for detailed instructions on the
        ///       appropriate use of this function. This function can only be called in an
        ///       external calibration session.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        ///  vi
        /// ViSession
        /// Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies the output channel to which these calibration settings apply.
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        ///  range
        /// ViReal64
        /// Specifies the range to calibrate with these settings.  Only one channel at a time may be calibrated.
        /// 
        /// </param>
        /// <param name="Number_Of_Measurements">
        /// 
        /// 
        ///  numberOfMeasurements
        /// ViUInt32
        /// Specifies the number of elements in requestedOutputs and measuredOutputs.
        /// 
        /// </param>
        /// <param name="Requested_Outputs">
        /// 
        /// 
        ///  requestedOutputs
        /// ViReal64[]
        /// Specifies an array of the output values requested in the niDCPower_ConfigureVoltageLevel function.
        /// 
        /// </param>
        /// <param name="Measured_Outputs">
        /// 
        /// 
        ///  measuredOutputs
        /// ViReal64[]
        /// Specifies an array of the output values measured by an external precision digital multimeter.
        /// 
        /// </param>
        public int CalAdjustVoltageLevel(string Channel_Name, double Range, uint Number_Of_Measurements, double[] Requested_Outputs, double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustVoltageLevel(this._handle, Channel_Name, Range, Number_Of_Measurements, Requested_Outputs, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_CalAdjustVoltageMeasurement
        /// 
        /// 
        ///  ViStatus niDCPower_CalAdjustVoltageMeasurement
        ///                    (ViSession vi, ViConstString channelName, ViReal64 range,
        ///                     ViUInt32 numberOfMeasurements, ViReal64 reportedOutputs[],
        ///                     ViReal64 measuredOutputs[]);
        ///  Purpose
        /// Calculates the calibration constants for the voltage measurements returned by the niDCPower_Measure
        ///  function for the specified output channel. This function compares the array in reportedOutputs to the array in measuredOutputs
        ///  and calculates the calibration constants for the voltage measurements returned by the niDCPower_Measure function.
        ///  Refer to the calibration procedure for the device you are calibrating for detailed instructions on the appropriate 
        ///  use of this function. This function can only be called in an external calibration session.
        ///  
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        ///  vi
        /// ViSession
        /// Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies the channel name to which these calibration settings apply.
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// </param>
        /// <param name="Number_Of_Measurements">
        /// 
        /// 
        ///  numberOfMeasurements
        /// ViUInt32
        /// Specifies the number of elements in reportedOutputs and measuredOutputs.
        /// 
        /// </param>
        /// <param name="Reported_Outputs">
        /// 
        /// 
        ///  reportedOutputs
        /// ViReal64[]
        /// Specifies an array of the output values that were returned by the niDCPower_Measure function.
        /// 
        /// </param>
        /// <param name="Measured_Outputs">
        /// 
        /// 
        ///  measuredOutputs
        /// ViReal64[]
        /// Specifies an array of the output values measured by an external precision digital multimeter.
        /// 
        /// </param>
        public int CalAdjustVoltageMeasurement(string Channel_Name, double Range, uint Number_Of_Measurements, double[] Reported_Outputs, double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustVoltageMeasurement(this._handle, Channel_Name, Range, Number_Of_Measurements, Reported_Outputs, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_CalAdjustCurrentLimit
        /// 
        /// 
        ///  ViStatus niDCPower_CalAdjustCurrentLimit (ViSession vi,
        ///                                                 ViConstString channelName,
        ///                                                 ViReal64 range,
        ///                                                 ViUInt32 numberOfMeasurements,
        ///                                                 ViReal64 requestedOutputs[],
        ///                                                 ViReal64 measuredOutputs[]);
        ///  Purpose
        /// Calculates the calibration constants for the current limit for the specified output channel and range. This function compares the array in requestedOutputs 
        /// to the array in measuredOutputs and calculates the calibration constants for the current limit returned by the device. Refer to the calibration procedure for the power 
        /// supply you are calibrating for detailed instructions on the appropriate use of this function. This function can only be called from an external calibration session.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies the channel name to which these calibration settings apply.
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// </param>
        /// <param name="Number_Of_Measurements">
        /// 
        /// 
        ///  numberOfMeasurements
        /// ViUInt32
        /// Specifies the number of elements in requestedOutputs and measuredOutputs.
        /// 
        /// </param>
        /// <param name="Requested_Outputs">
        /// 
        /// 
        ///  requestedOutputs
        /// ViReal64[]
        /// Specifies an array of the output values that were requested in the niDCPower_ConfigureCurrentLimit function.
        /// 
        /// </param>
        /// <param name="Measured_Outputs">
        /// 
        /// 
        ///  measuredOutputs
        /// ViReal64[]
        /// Specifies an array of the output values measured by an external precision digital multimeter.
        /// 
        /// </param>
        public int CalAdjustCurrentLimit(string Channel_Name, double Range, uint Number_Of_Measurements, double[] Requested_Outputs, double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustCurrentLimit(this._handle, Channel_Name, Range, Number_Of_Measurements, Requested_Outputs, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_CalAdjustCurrentMeasurement
        /// 
        /// 
        ///  ViStatus niDCPower_CalAdjustCurrentMeasurement
        ///                    (ViSession vi, ViConstString channelName,
        ///                     ViReal64 range, ViUInt32 numberOfMeasurements,
        ///                     ViReal64 reportedOutputs[], ViReal64 measuredOutputs[]);
        ///  Purpose
        /// Calibrates the current measurements returned by the niDCPower_Measure function for the specified output channel. This function calculates the 
        /// calibration constants for the array in reportedOutputs to the array in measuredOutputs and calculates the calibration constants for the current 
        /// measurements returned by the niDCPower_Measure function. Refer to the calibration procedure for the device you are calibrating for detailed instructions 
        /// about the appropriate use of this function. This function can only be called in an external calibration session.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        ///  vi
        /// ViSession
        /// Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies the output channel name to which these calibration settings apply.
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// </param>
        /// <param name="Number_Of_Measurements">
        /// 
        /// 
        ///  numberOfMeasurements
        /// ViUInt32
        /// Specifies the number of elements in reportedOutputs and measuredOutputs.
        /// 
        /// </param>
        /// <param name="Reported_Outputs">
        /// 
        /// 
        /// reportedOutputs
        /// ViReal64[]
        /// Specifies an array of the output values that were returned by the niDCPower_Measure function.
        /// 
        /// </param>
        /// <param name="Measured_Outputs">
        /// 
        /// 
        /// measuredOutputs
        /// ViReal64[]
        /// Specifies an array of the output values measured by an external precision digital multimeter.
        /// 
        /// </param>
        public int CalAdjustCurrentMeasurement(string Channel_Name, double Range, uint Number_Of_Measurements, double[] Reported_Outputs, double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustCurrentMeasurement(this._handle, Channel_Name, Range, Number_Of_Measurements, Reported_Outputs, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ChangeExtCalPassword
        /// 
        /// 
        ///  ViStatus niDCPower_ChangeExtCalPassword (ViSession vi,
        ///                                                ViConstString oldPassword,
        ///                                                ViConstString newPassword);
        ///  Purpose
        /// Changes the password that is required to initialize an external calibration session. The password can be a maximum of four alphanumeric characters. If you call this function in a regular session, password is changed immediately. If you call this function in an external calibration session, password is changed only after you close the session using the niDCPower_CloseExtCal function with action set to NIDCPOWER_VAL_COMMIT.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        ///  vi
        /// ViSession
        /// Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        /// 
        /// </param>
        /// <param name="Old_Password">
        /// 
        /// 
        ///  oldPassword
        /// ViConstString
        /// Specifies the previous password used to protect the calibration values.
        /// 
        /// </param>
        /// <param name="New_Password">
        /// 
        /// 
        ///  newPassword
        /// ViConstString
        /// Specifies the new password to use to protect the calibration values.
        /// 
        /// </param>
        public int ChangeExtCalPassword(string Old_Password, string New_Password)
        {
            int pInvokeResult = PInvoke.ChangeExtCalPassword(this._handle, Old_Password, New_Password);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_GetExtCalRecommendedInterval
        /// 
        /// 
        ///  ViStatus niDCPower_GetExtCalRecommendedInterval
        ///                    (ViSession vi, ViInt32 *months);
        ///  Purpose
        /// Returns the recommended maximum interval, in months, between external calibrations.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        ///  vi
        /// ViSession
        /// Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        /// 
        /// </param>
        /// <param name="Months">
        /// 
        /// 
        ///  months
        /// ViInt32*
        /// Specifies the recommended maximum interval, in months, between external calibrations in months.
        /// 
        /// </param>
        public int GetExtCalRecommendedInterval(out int Months)
        {
            int pInvokeResult = PInvoke.GetExtCalRecommendedInterval(this._handle, out Months);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_GetExtCalLastDateAndTime
        /// 
        /// 
        ///  ViStatus niDCPower_GetExtCalLastDateAndTime (ViSession vi,
        ///                                                    ViInt32 *year,
        ///                                                    ViInt32 *month,
        ///                                                    ViInt32 *day,
        ///                                                    ViInt32 *hour,
        ///                                                    ViInt32 *minute);
        ///  Purpose
        /// Returns the date and time of the last successful calibration. The time returned is 24-hour (military) local time; for example, if the device was calibrated at 2:30 PM, this function returns 14 for hours and 30 for minutes.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        ///  vi
        /// ViSession
        /// Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        /// 
        /// </param>
        /// <param name="Year">
        /// 
        /// 
        ///  year
        /// ViInt32*
        /// Returns the year the device was last calibrated.
        /// 
        /// </param>
        /// <param name="Month">
        /// 
        /// 
        ///  month
        /// ViInt32*
        /// Returns the month in which the device was last calibrated.
        /// 
        /// </param>
        /// <param name="Day">
        /// 
        /// 
        ///  day
        /// ViInt32*
        /// Returns the day on which the device was last calibrated.
        /// 
        /// </param>
        /// <param name="Hour">
        /// 
        /// 
        ///  hour
        /// ViInt32*
        /// Returns the hour (in 24-hour time) in which the device was last calibrated.
        /// 
        /// </param>
        /// <param name="Minute">
        /// 
        /// 
        ///  minute
        /// ViInt32*
        /// Returns the minute in which the device was last calibrated.
        /// 
        /// </param>
        public int GetExtCalLastDateAndTime(out int Year, out int Month, out int Day, out int Hour, out int Minute)
        {
            int pInvokeResult = PInvoke.GetExtCalLastDateAndTime(this._handle, out Year, out Month, out Day, out Hour, out Minute);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_GetCalUserDefinedInfoMaxSize
        /// 
        /// 
        ///  ViStatus niDCPower_GetCalUserDefinedInfoMaxSize
        ///                    (ViSession vi, ViInt32*infoSize);
        ///  Purpose
        /// Returns the maximum number of characters that can be used to store user-defined information in the device onboard EEPROM.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        ///  vi
        /// ViSession
        /// Identifies a particular instrument session. vi is obtained from 
        /// the niDCPower_init or 
        /// the niDCPower_InitWithOptions 
        /// function.
        /// 
        /// </param>
        /// <param name="Info_Size">
        /// 
        /// 
        ///  infoSize
        /// ViInt32*
        /// Returns the number of characters that can be stored in the device onboard EEPROM.
        /// 
        /// </param>
        public int GetCalUserDefinedInfoMaxSize(out int Info_Size)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfoMaxSize(this._handle, out Info_Size);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_SetCalUserDefinedInfo
        /// 
        /// 
        ///  ViStatus niDCPower_SetCalUserDefinedInfo (ViSession vi,
        ///                                                 ViConstString info);
        ///  Purpose
        /// Stores a user-defined string of characters in the device onboard EEPROM. If the string is longer than the maximum allowable size, it is truncated. This function overwrites any existing user-defined information. If you call this function in a regular session, info is immediately changed. If you call this function in an external calibration session, info is changed only after you close the session using the niDCPower_CloseExtCal function with action set to NIDCPOWER_VAL_COMMIT.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Info">
        /// 
        ///  info
        /// ViConstString
        /// Specifies the string to store in the device onboard EEPROM.
        /// 
        /// </param>
        public int SetCalUserDefinedInfo(string Info)
        {
            int pInvokeResult = PInvoke.SetCalUserDefinedInfo(this._handle, Info);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_GetCalUserDefinedInfo
        /// 
        /// 
        ///  ViStatus niDCPower_GetCalUserDefinedInfo (ViSession vi,
        ///                                                 ViString info);
        ///  Purpose
        /// Returns the user-defined information in the device onboard EEPROM.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        ///  vi
        /// ViSession
        /// Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        /// 
        /// </param>
        /// <param name="Info">
        /// 
        /// 
        ///  info
        /// ViString
        /// Returns the user-defined information stored in the device onboard EEPROM.
        /// 
        /// </param>
        public int GetCalUserDefinedInfo(System.Text.StringBuilder Info)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfo(this._handle, Info);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_ReadCurrentTemperature
        /// 
        /// 
        ///  ViStatus niDCPower_ReadCurrentTemperature (ViSession vi,
        ///                                                  ViReal64 *temperature);
        ///  Purpose
        /// Returns the current onboard temperature, in degrees Celsius, of the device.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Temperature">
        /// 
        ///  temperature
        /// ViReal64*
        /// Returns the onboard temperature, in degrees Celsius, of the device.
        /// 
        /// </param>
        public int ReadCurrentTemperature(out double Temperature)
        {
            int pInvokeResult = PInvoke.ReadCurrentTemperature(this._handle, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_GetExtCalLastTemp
        /// 
        /// 
        ///  ViStatus niDCPower_GetExtCalLastTemp (ViSession vi,
        ///                                             ViReal64 *temperature);
        ///  Purpose
        /// Returns the onboard temperature of the device, in degrees Celsius, during the last successful external calibration.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// 
        ///  vi
        /// ViSession
        /// Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        /// 
        /// </param>
        /// <param name="Temperature">
        /// 
        /// 
        ///  temperature
        /// ViReal64*
        /// Returns the onboard temperature of the device, in degrees Celsius, during the last successful external calibration.
        /// 
        /// </param>
        public int GetExtCalLastTemp(out double Temperature)
        {
            int pInvokeResult = PInvoke.GetExtCalLastTemp(this._handle, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_Disable
        /// 
        /// 
        ///  ViStatus niDCPower_Disable (ViSession vi);
        ///  Purpose
        /// Places the device in a quiescent state where it has minimal or no impact on the system to which it is connected. The power output and all exported signals are disabled. This function performs the same actions as the niDCPower_reset function.  
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        public int Disable()
        {
            int pInvokeResult = PInvoke.Disable(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_reset
        /// 
        /// 
        ///  ViStatus niDCPower_reset (ViSession vi);
        ///  Purpose
        /// Resets the device to a known state.  This function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in  Immediate mode.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        public int reset()
        {
            int pInvokeResult = PInvoke.reset(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_ResetDevice
        /// 
        /// 
        ///  ViStatus niDCPower_ResetDevice (ViSession vi);
        ///  Purpose
        /// Resets the device to a known state.  The function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in  Immediate mode.
        /// The niDCPower_ResetDevice function performs a hard reset on the device and the driver software. This function has the same functionality as using reset in Measurement &amp; Automation Explorer.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        public int ResetDevice()
        {
            int pInvokeResult = PInvoke.ResetDevice(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_self_test
        /// 
        /// 
        ///  ViStatus niDCPower_self_test (ViSession vi,
        ///                                     ViInt16 *selfTestResult,
        ///                                     ViChar selfTestMessage[]);
        ///  Purpose
        /// Performs the device self-test routine and returns the test result(s). Calling this function implicitly calls the niDCPower_reset function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Self_Test_Result">
        /// 
        ///  selfTestResult
        /// ViInt16*
        /// Returns the value result from the device self-test.
        /// 
        /// 
        /// Self-Test CodeDescription0Self test passed.
        /// 1Self test failed.
        /// 
        /// </param>
        /// <param name="Self_Test_Message">
        /// 
        ///  selfTestMessage
        /// ViChar[]
        /// Returns the self-test result message. The size of this array must be at least 256 bytes.
        /// 
        /// </param>
        public int self_test(out short Self_Test_Result, System.Text.StringBuilder Self_Test_Message)
        {
            int pInvokeResult = PInvoke.self_test(this._handle, out Self_Test_Result, Self_Test_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_revision_query
        /// 
        /// 
        ///  ViStatus niDCPower_revision_query (ViSession vi,
        ///                                          ViChar instrumentDriverRevision[],
        ///                                          ViChar firmwareRevision[]);
        ///  Purpose
        /// Returns the revision information of NI-DCPower and the device firmware.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Instrument_Driver_Revision">
        /// 
        ///  instrumentDriverRevision
        /// ViChar[]
        /// Returns the driver revision information for NI-DCPower.
        /// 
        /// </param>
        /// <param name="Firmware_Revision">
        /// 
        ///  firmwareRevision
        /// ViChar[]
        /// Returns firmware revision information for the device you are using. The size of this array must be at least 256 bytes.
        /// 
        /// </param>
        public int revision_query(System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision)
        {
            int pInvokeResult = PInvoke.revision_query(this._handle, Instrument_Driver_Revision, Firmware_Revision);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_ResetWithDefaults
        /// 
        /// 
        ///  ViStatus niDCPower_ResetWithDefaults (ViSession vi);
        ///  Purpose
        /// Resets the device to a known state. This function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in  Immediate mode. In addition to exhibiting the behavior of the niDCPower_reset function, this function can assign user-defined default values for configurable attributes from the IVI configuration.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        public int ResetWithDefaults()
        {
            int pInvokeResult = PInvoke.ResetWithDefaults(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_GetChannelName
        /// 
        ///   ViStatus niDCPower_GetChannelName (ViSession vi,
        ///                                          ViInt32 index, ViInt32 bufferSize,
        ///                                          ViChar channelName[]);
        ///  Purpose
        /// Retrieves the output channelName that corresponds to the requested index. Use the 
        /// NIDCPOWER_ATTR_CHANNEL_COUNT
        ///  attribute to determine the upper bound of valid values for index.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Index">
        /// 
        /// 
        ///  index
        /// ViInt32
        /// Specifies which output channel name to return. The index values begin at 1.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// 
        /// 
        ///  bufferSize
        /// ViInt32
        /// Specifies the number of bytes in the ViChar array you specify for channelName. If the channelName, including the terminating NUL byte, contains more bytes than you indicate in this attribute, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is 123456 and the buffer size is 4, the function places 123 into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for channelName.
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        ///  channelName
        /// ViChar[]
        /// Returns the output channel name that corresponds to index.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        ///  StatusViStatusReports the status of this operation. To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.
        /// 
        /// </returns>
        public int GetChannelName(int Index, int Buffer_Size, System.Text.StringBuilder Channel_Name)
        {
            int pInvokeResult = PInvoke.GetChannelName(this._handle, Index, Buffer_Size, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_GetNextCoercionRecord
        /// 
        ///  ViStatus niDCPower_GetNextCoercionRecord (ViSession vi,
        ///                                                 ViInt32 bufferSize,
        ///                                                 ViChar coercionRecord[]);
        ///  Purpose
        /// Returns the coercion information associated with the IVI session and clears the earliest instance in which NI-DCPower coerced a value you specified.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// 
        /// 
        ///  bufferSize
        /// ViInt32
        /// Specifies the number of bytes in the ViChar array you specify for coercionRecord. If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this attribute, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is 123456 and the buffer size is 4, the function places 123 into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for coercionRecord.
        /// 
        /// </param>
        /// <param name="Coercion_Record">
        /// 
        /// 
        ///  coercionRecord
        /// ViChar[]
        /// Returns the next coercionRecord for the IVI session. If there are no coercionRecords, the function returns an empty string.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        ///  StatusViStatusReports the status of this operation. To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.
        /// 
        /// </returns>
        public int GetNextCoercionRecord(int Buffer_Size, System.Text.StringBuilder Coercion_Record)
        {
            int pInvokeResult = PInvoke.GetNextCoercionRecord(this._handle, Buffer_Size, Coercion_Record);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_ClearInterchangeWarnings
        /// 
        /// 
        ///  ViStatus niDCPower_ClearInterchangeWarnings
        ///                    (ViSession vi);
        ///  Purpose
        /// Clears the list of current interchange warnings.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        public int ClearInterchangeWarnings()
        {
            int pInvokeResult = PInvoke.ClearInterchangeWarnings(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// niDCPower_ResetInterchangeCheck
        /// 
        /// 
        ///  ViStatus niDCPower_ResetInterchangeCheck (ViSession vi);
        ///  Purpose
        /// When developing a complex test system that consists of multiple test
        ///       modules, it is generally a good idea to design the test modules so that
        ///       they can run in any order.  To do so requires ensuring that each test
        ///       module completely configures the state of each instrument it uses.  If a
        ///       particular test module does not completely configure the state of an
        ///       instrument, the state of the instrument depends on the configuration from
        ///       a previously executed test module.  If you execute the test modules in a
        ///       different order, the behavior of the instrument and therefore the entire
        ///       test module is likely to change.  This change in behavior is generally
        ///       instrument specific and represents an interchangeability problem.
        /// 	  You can use this function to test for such cases.  After you call this
        ///       function, the interchangeability checking algorithms in the specific
        ///       driver ignore all previous configuration operations.  By calling this
        ///       function at the beginning of a test module, you can determine whether the
        ///       test module has dependencies on the operation of previously executed test
        ///       modules.This function does not clear the interchangeability warnings from the
        ///       list of previously recorded interchangeability warnings.  If you want to
        ///       guarantee that the niDCPower_GetNextInterchangeWarning function only
        ///       returns those interchangeability warnings that are generated after
        ///       calling this function, you must clear the list of interchangeability
        ///       warnings.  You can clear the interchangeability warnings list by
        ///       repeatedly calling the niDCPower_GetNextInterchangeWarning function until
        ///       no more interchangeability warnings are returned.  If you are not
        ///       interested in the content of those warnings, you can call the
        ///       niDCPower_ClearInterchangeWarnings function.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        public int ResetInterchangeCheck()
        {
            int pInvokeResult = PInvoke.ResetInterchangeCheck(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// niDCPower_GetNextInterchangeWarning
        /// 
        /// 
        ///  ViStatus niDCPower_GetNextInterchangeWarning (ViSession vi,
        ///                                                     ViInt32 bufferSize,
        ///                                                     ViChar interchangeWarning[]);
        ///  Purpose
        /// This function returns the interchangeability warning associated with the IVI session. It retrieves and clears the earliest instance in which the class driver recorded an interchangeability warning. Interchangeability warnings indicate that using your application with a different device may cause a different behavior. 
        /// NI-DCPower performs interchangeability checking when the NIDCPOWER_ATTR_INTERCHANGE_CHECK attribute is set to VI_TRUE. This function returns an empty string in warning if no interchangeability warnings remain for the session. In general, NI-DCPower generates interchangeability warnings when an attribute that affects the behavior of the device is in a state that you did not specify.
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// 
        /// 
        ///  bufferSize
        /// ViInt32
        /// Specifies the number of bytes in the ViChar array you specify for interchangeWarning. If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate in this attribute, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is 123456 and the buffer size is 4, the function places 123 into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for interchangeWarning.
        /// 
        /// </param>
        /// <param name="Interchange_Warning">
        ///  
        /// 
        ///  interchangeWarning
        /// ViChar[]
        /// Returns the next interchange warning for the IVI session. If there are no interchange warnings, the function returns an empty string.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        ///  StatusViStatusReports the status of this operation. To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.
        /// 
        /// </returns>
        public int GetNextInterchangeWarning(int Buffer_Size, System.Text.StringBuilder Interchange_Warning)
        {
            int pInvokeResult = PInvoke.GetNextInterchangeWarning(this._handle, Buffer_Size, Interchange_Warning);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// Obsolete
        /// </summary>
        /// <param name="Instrument_Handle">
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        ///  channelName
        /// ViConstString
        /// Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        /// of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        /// 
        /// </param>
        /// <param name="Range_Type">
        /// 
        /// </param>
        /// <param name="Range">
        /// 
        /// 
        ///  range
        /// ViReal64
        /// Specifies the voltage level range, in volts, on the specified channel(s).
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Valid Values:
        /// 
        /// 
        /// NI PXI-4110
        /// ChannelVoltage Level Range (V)Voltage Level (V)
        /// 060 to +6
        /// 1200 to +20
        /// 2200 to -20
        /// 
        /// 
        /// NI PXI-4130
        /// 
        /// ChannelVoltage Level Range (V)Voltage Level (V)
        /// 060 to +6
        /// 16-6 to +6
        /// 20-20 to +20
        /// 
        /// Note&#160;&#160;  If a range other than what is listed in the preceding table is selected, it will be coerced to the next-highest range.  For example, requesting the 10 V voltage level range on Channel 1 on the NI-PXI 4130 coerces the voltage level range to 20 V.  Refer to the Ranges topic in the NI DC Power Supplies and SMUs Help for more information about coercion.
        /// 
        /// 
        /// 
        /// 
        /// </param>
        public int ConfigureOutputRange(string Channel_Name, int Range_Type, double Range)
        {
            int pInvokeResult = PInvoke.ConfigureOutputRange(this._handle, Channel_Name, Range_Type, Range);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        public void Dispose()
        {
            this.Dispose(true);
            System.GC.SuppressFinalize(this);
        }

        private void Dispose(bool disposing)
        {
            if ((this._disposed == false))
            {
                PInvoke.close(this._handle);
                this._handle = System.IntPtr.Zero;
            }
            this._disposed = true;
        }

        public void SetInt32(nidcpowerProperties propertyId, string repeatedCapabilityOrChannel, int val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }

        public void SetInt32(nidcpowerProperties propertyId, int val)
        {
            this.SetInt32(propertyId, "", val);
        }

        public int GetInt32(nidcpowerProperties propertyId, string repeatedCapabilityOrChannel)
        {
            int val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }

        public int GetInt32(nidcpowerProperties propertyId)
        {
            return this.GetInt32(propertyId, "");
        }

        public void SetDouble(nidcpowerProperties propertyId, string repeatedCapabilityOrChannel, double val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }

        public void SetDouble(nidcpowerProperties propertyId, double val)
        {
            this.SetDouble(propertyId, "", val);
        }

        public double GetDouble(nidcpowerProperties propertyId, string repeatedCapabilityOrChannel)
        {
            double val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }

        public double GetDouble(nidcpowerProperties propertyId)
        {
            return this.GetDouble(propertyId, "");
        }

        public void SetBoolean(nidcpowerProperties propertyId, string repeatedCapabilityOrChannel, bool val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), System.Convert.ToUInt16(val)));
        }

        public void SetBoolean(nidcpowerProperties propertyId, bool val)
        {
            this.SetBoolean(propertyId, "", val);
        }

        public bool GetBoolean(nidcpowerProperties propertyId, string repeatedCapabilityOrChannel)
        {
            ushort val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return System.Convert.ToBoolean(val);
        }

        public bool GetBoolean(nidcpowerProperties propertyId)
        {
            return this.GetBoolean(propertyId, "");
        }

        public void SetString(nidcpowerProperties propertyId, string repeatedCapabilityOrChannel, string val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }

        public void SetString(nidcpowerProperties propertyId, string val)
        {
            this.SetString(propertyId, "", val);
        }

        public string GetString(nidcpowerProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.Text.StringBuilder newVal = new System.Text.StringBuilder(512);
            int size = PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), 512, newVal);
            if ((size < 0))
            {
                PInvoke.ThrowError(this._handle, size);
            }
            else
            {
                if ((size > 0))
                {
                    newVal.Capacity = size;
                    PInvoke.TestForError(this._handle, PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), size, newVal));
                }
            }
            return newVal.ToString();
        }

        public string GetString(nidcpowerProperties propertyId)
        {
            return this.GetString(propertyId, "");
        }

        private class PInvoke
        {

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_init", CallingConvention = CallingConvention.StdCall)]
            public static extern int init(string Resource_Name, ushort ID_Query, ushort Reset_Device, out System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_InitExtCal", CallingConvention = CallingConvention.StdCall)]
            public static extern int InitExtCal(string Resource_Name, string Password, out System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_InitWithOptions", CallingConvention = CallingConvention.StdCall)]
            public static extern int InitWithOptions(string Resource_Name, ushort ID_Query, ushort Reset_Device, string Option_String, out System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureOutputEnabled", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureOutputEnabled(System.IntPtr Instrument_Handle, string Channel_Name, ushort Enabled);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureOutputFunction", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureOutputFunction(System.IntPtr Instrument_Handle, string Channel_Name, int Function);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_MeasureMultiple", CallingConvention = CallingConvention.StdCall)]
            public static extern int MeasureMultiple(System.IntPtr Instrument_Handle, string Channel_Name, [In, Out] double[] Voltage_Measurements, [In, Out] double[] Current_Measurements);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureSense", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureSense(System.IntPtr Instrument_Handle, string Channel_Name, int Sense);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_Initiate", CallingConvention = CallingConvention.StdCall)]
            public static extern int Initiate(System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_Abort", CallingConvention = CallingConvention.StdCall)]
            public static extern int Abort(System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureVoltageLevel", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureVoltageLevel(System.IntPtr Instrument_Handle, string Channel_Name, double Level);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureVoltageLevelRange", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureVoltageLevelRange(System.IntPtr Instrument_Handle, string Channel_Name, double Range);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureCurrentLimit", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureCurrentLimit(System.IntPtr Instrument_Handle, string Channel_Name, int Behavior, double Limit);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureCurrentLimitRange", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureCurrentLimitRange(System.IntPtr Instrument_Handle, string Channel_Name, double Range);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureCurrentLevel", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureCurrentLevel(System.IntPtr Instrument_Handle, string Channel_Name, double Level);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureCurrentLevelRange", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureCurrentLevelRange(System.IntPtr Instrument_Handle, string Channel_Name, double Range);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureVoltageLimit", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureVoltageLimit(System.IntPtr Instrument_Handle, string Channel_Name, double Limit);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureVoltageLimitRange", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureVoltageLimitRange(System.IntPtr Instrument_Handle, string Channel_Name, double Range);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_QueryOutputState", CallingConvention = CallingConvention.StdCall)]
            public static extern int QueryOutputState(System.IntPtr Instrument_Handle, string Channel_Name, int Output_State, out ushort In_State);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_QueryInCompliance", CallingConvention = CallingConvention.StdCall)]
            public static extern int QueryInCompliance(System.IntPtr Instrument_Handle, string Channel_Name, out ushort In_Compliance);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_Measure", CallingConvention = CallingConvention.StdCall)]
            public static extern int Measure(System.IntPtr Instrument_Handle, string Channel_Name, int Measurement_Type, out double Measurement);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_QueryMaxCurrentLimit", CallingConvention = CallingConvention.StdCall)]
            public static extern int QueryMaxCurrentLimit(System.IntPtr Instrument_Handle, string Channel_Name, double Voltage_Level, out double Max_Current_Limit);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_QueryMaxVoltageLevel", CallingConvention = CallingConvention.StdCall)]
            public static extern int QueryMaxVoltageLevel(System.IntPtr Instrument_Handle, string Channel_Name, double Current_Limit, out double Max_Voltage_Level);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_QueryMinCurrentLimit", CallingConvention = CallingConvention.StdCall)]
            public static extern int QueryMinCurrentLimit(System.IntPtr Instrument_Handle, string Channel_Name, double Voltage_Level, out double Min_Current_Limit);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_CloseExtCal", CallingConvention = CallingConvention.StdCall)]
            public static extern int CloseExtCal(System.IntPtr Instrument_Handle, int Action);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_CalAdjustVoltageLevel", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustVoltageLevel(System.IntPtr Instrument_Handle, string Channel_Name, double Range, uint Number_Of_Measurements, double[] Requested_Outputs, double[] Measured_Outputs);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_CalAdjustVoltageMeasurement", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustVoltageMeasurement(System.IntPtr Instrument_Handle, string Channel_Name, double Range, uint Number_Of_Measurements, double[] Reported_Outputs, double[] Measured_Outputs);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_CalAdjustCurrentLimit", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustCurrentLimit(System.IntPtr Instrument_Handle, string Channel_Name, double Range, uint Number_Of_Measurements, double[] Requested_Outputs, double[] Measured_Outputs);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_CalAdjustCurrentMeasurement", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustCurrentMeasurement(System.IntPtr Instrument_Handle, string Channel_Name, double Range, uint Number_Of_Measurements, double[] Reported_Outputs, double[] Measured_Outputs);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ChangeExtCalPassword", CallingConvention = CallingConvention.StdCall)]
            public static extern int ChangeExtCalPassword(System.IntPtr Instrument_Handle, string Old_Password, string New_Password);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetExtCalRecommendedInterval", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetExtCalRecommendedInterval(System.IntPtr Instrument_Handle, out int Months);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetExtCalLastDateAndTime", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetExtCalLastDateAndTime(System.IntPtr Instrument_Handle, out int Year, out int Month, out int Day, out int Hour, out int Minute);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetCalUserDefinedInfoMaxSize", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfoMaxSize(System.IntPtr Instrument_Handle, out int Info_Size);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_SetCalUserDefinedInfo", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetCalUserDefinedInfo(System.IntPtr Instrument_Handle, string Info);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetCalUserDefinedInfo", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfo(System.IntPtr Instrument_Handle, System.Text.StringBuilder Info);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ReadCurrentTemperature", CallingConvention = CallingConvention.StdCall)]
            public static extern int ReadCurrentTemperature(System.IntPtr Instrument_Handle, out double Temperature);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetExtCalLastTemp", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetExtCalLastTemp(System.IntPtr Instrument_Handle, out double Temperature);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_Disable", CallingConvention = CallingConvention.StdCall)]
            public static extern int Disable(System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_reset", CallingConvention = CallingConvention.StdCall)]
            public static extern int reset(System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ResetDevice", CallingConvention = CallingConvention.StdCall)]
            public static extern int ResetDevice(System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_self_test", CallingConvention = CallingConvention.StdCall)]
            public static extern int self_test(System.IntPtr Instrument_Handle, out short Self_Test_Result, System.Text.StringBuilder Self_Test_Message);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_revision_query", CallingConvention = CallingConvention.StdCall)]
            public static extern int revision_query(System.IntPtr Instrument_Handle, System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ResetWithDefaults", CallingConvention = CallingConvention.StdCall)]
            public static extern int ResetWithDefaults(System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetChannelName", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetChannelName(System.IntPtr Instrument_Handle, int Index, int Buffer_Size, System.Text.StringBuilder Channel_Name);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetNextCoercionRecord", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetNextCoercionRecord(System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Coercion_Record);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ClearInterchangeWarnings", CallingConvention = CallingConvention.StdCall)]
            public static extern int ClearInterchangeWarnings(System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ResetInterchangeCheck", CallingConvention = CallingConvention.StdCall)]
            public static extern int ResetInterchangeCheck(System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetNextInterchangeWarning", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetNextInterchangeWarning(System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Interchange_Warning);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_ConfigureOutputRange", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureOutputRange(System.IntPtr Instrument_Handle, string Channel_Name, int Range_Type, double Range);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_close", CallingConvention = CallingConvention.StdCall)]
            public static extern int close(System.IntPtr Instrument_Handle);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_error_message", CallingConvention = CallingConvention.StdCall)]
            public static extern int error_message(System.IntPtr Instrument_Handle, int Error_Code, System.Text.StringBuilder Error_Message_2);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetAttributeViInt32", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViInt32(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out int Attribute_Value);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetAttributeViReal64", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViReal64(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out double Attribute_Value);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetAttributeViString", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViString(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Buffer_Size, System.Text.StringBuilder Attribute_Value);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetAttributeViBoolean", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViBoolean(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out ushort Attribute_Value);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetAttributeViSession", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViSession(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.IntPtr Attribute_Value);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_SetAttributeViInt32", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViInt32(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Attribute_Value);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_SetAttributeViReal64", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViReal64(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, double Attribute_Value);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_SetAttributeViString", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViString(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, string Attribute_Value);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_SetAttributeViBoolean", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViBoolean(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, ushort Attribute_Value);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_SetAttributeViSession", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViSession(System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.IntPtr Attribute_Value);

            [DllImport("niDCPower_32.dll", EntryPoint = "niDCPower_GetError", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetError(System.IntPtr Instrument_Handle, out int Code, int BufferSize, System.Text.StringBuilder Description);


            public static int TestForError(System.IntPtr handle, int status)
            {
                if ((status < 0))
                {
                    PInvoke.ThrowError(handle, status);
                }
                return status;
            }

            public static int ThrowError(System.IntPtr handle, int code)
            {
                int status;
                int size = PInvoke.GetError(handle, out status, 0, null);
                System.Text.StringBuilder msg = new System.Text.StringBuilder();
                if ((size >= 0))
                {
                    msg.Capacity = size;
                    PInvoke.GetError(handle, out status, size, msg);
                }
                throw new System.Runtime.InteropServices.ExternalException(msg.ToString(), code);
            }
        }
    }

    public class nidcpowerConstants
    {

        public const int DcVoltage = 1006;

        public const int DcCurrent = 1007;

        public const int Local = 1008;

        public const int Remote = 1009;

        public const int CurrentRegulate = 0;

        public const int OutputConstantVoltage = 0;

        public const int OutputConstantCurrent = 1;

        public const int MeasureVoltage = 1;

        public const int MeasureCurrent = 0;

        public const int Cancel = 1001;

        public const int Commit = 1002;

        public const int RangeVoltage = 1;

        public const int RangeCurrent = 0;

        public const int Off = 0;

        public const int On = 1;

        public const int Internal = 1003;

        public const int Auxiliary = 1004;

        public const int Automatic = 1005;

        public const int Low = 1010;

        public const int High = 1011;
    }

    public enum nidcpowerProperties
    {

        /// <summary>
        /// System.Boolean
        /// </summary>
        OutputEnabled = 1250006,

        /// <summary>
        /// System.Int32
        /// </summary>
        OutputFunction = 1150008,

        /// <summary>
        /// System.Int32
        /// </summary>
        Sense = 1150013,

        /// <summary>
        /// System.Double
        /// </summary>
        VoltageLevel = 1250001,

        /// <summary>
        /// System.Double
        /// </summary>
        CurrentLimit = 1250005,

        /// <summary>
        /// System.Double
        /// </summary>
        VoltageLevelRange = 1150005,

        /// <summary>
        /// System.Double
        /// </summary>
        CurrentLimitRange = 1150004,

        /// <summary>
        /// System.Int32
        /// </summary>
        VoltageLevelAutorange = 1150015,

        /// <summary>
        /// System.Int32
        /// </summary>
        CurrentLimitAutorange = 1150016,

        /// <summary>
        /// System.Double
        /// </summary>
        CurrentLevel = 1150009,

        /// <summary>
        /// System.Double
        /// </summary>
        VoltageLimit = 1150010,

        /// <summary>
        /// System.Double
        /// </summary>
        CurrentLevelRange = 1150011,

        /// <summary>
        /// System.Double
        /// </summary>
        VoltageLimitRange = 1150012,

        /// <summary>
        /// System.Int32
        /// </summary>
        CurrentLevelAutorange = 1150017,

        /// <summary>
        /// System.Int32
        /// </summary>
        VoltageLimitAutorange = 1150018,

        /// <summary>
        /// System.Int32
        /// </summary>
        PowerSource = 1150000,

        /// <summary>
        /// System.Int32
        /// </summary>
        PowerSourceInUse = 1150001,

        /// <summary>
        /// System.Boolean
        /// </summary>
        AuxiliaryPowerSourceAvailable = 1150002,

        /// <summary>
        /// System.Int32
        /// </summary>
        SamplesToAverage = 1150003,

        /// <summary>
        /// System.Boolean
        /// </summary>
        ResetAverageBeforeMeasurement = 1150006,

        /// <summary>
        /// System.Boolean
        /// </summary>
        OverrangingEnabled = 1150007,

        /// <summary>
        /// System.Int32
        /// </summary>
        OutputCapacitance = 1150014,

        /// <summary>
        /// System.Boolean
        /// </summary>
        RangeCheck = 1050002,

        /// <summary>
        /// System.Boolean
        /// </summary>
        QueryInstrumentStatus = 1050003,

        /// <summary>
        /// System.Boolean
        /// </summary>
        Cache = 1050004,

        /// <summary>
        /// System.Boolean
        /// </summary>
        Simulate = 1050005,

        /// <summary>
        /// System.Boolean
        /// </summary>
        RecordCoercions = 1050006,

        /// <summary>
        /// System.Boolean
        /// </summary>
        InterchangeCheck = 1050021,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverDescription = 1050514,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverPrefix = 1050302,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverVendor = 1050513,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverRevision = 1050551,

        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMajorVersion = 1050515,

        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMinorVersion = 1050516,

        /// <summary>
        /// System.String
        /// </summary>
        SupportedInstrumentModels = 1050327,

        /// <summary>
        /// System.String
        /// </summary>
        GroupCapabilities = 1050401,

        /// <summary>
        /// System.Int32
        /// </summary>
        ChannelCount = 1050203,

        /// <summary>
        /// System.String
        /// </summary>
        InstrumentManufacturer = 1050511,

        /// <summary>
        /// System.String
        /// </summary>
        InstrumentModel = 1050512,

        /// <summary>
        /// System.String
        /// </summary>
        InstrumentFirmwareRevision = 1050510,

        /// <summary>
        /// System.String
        /// </summary>
        LogicalName = 1050305,

        /// <summary>
        /// System.String
        /// </summary>
        IoResourceDescriptor = 1050304,

        /// <summary>
        /// System.String
        /// </summary>
        DriverSetup = 1050007,
    }
}
