'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by Measurement Studio.
'     Runtime Version:2.0.50727.832
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------

Option Strict Off
Option Explicit On

Imports System
Imports System.Runtime.InteropServices

Namespace NationalInstruments.ModularInstruments.Interop

    Public Class nidcpower
        Inherits Object
        Implements System.IDisposable

        Private _handle As System.IntPtr

        Private _disposed As Boolean = True

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_init
        '''''
        ''''' ViStatus niDCPower_init (ViRsrc resourceName, ViBoolean IDQuery,
        '''''                               ViBoolean resetDevice,
        '''''                               ViSession vi);
        ''''' Purpose
        '''''Creates a new IVI instrument driver session to the device specified
        '''''      in resourceName and returns a session handle you use to identify the
        '''''      device in all subsequent NI-DCPower function calls. This function
        '''''      also sends initialization commands to set the device to the state
        '''''      necessary for the operation of NI-DCPower. 
        '''''	  
        '''''To place the device in a known start-up state when creating a new session, set resetDevice to VI_TRUE. This action is equivalent to using the niDCPower_reset function.
        '''''
        '''''To open a session and leave the device in its existing configuration without passing through a transitional output state, set resetDevice to VI_FALSE, and immediately call the niDCPower_Abort function. To apply a new configuration without disrupting the output channels of the device, configure the device in Delayed Configuration mode as in the previous session changing only the desired settings, and then call niDCPower_Initiate function.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Resource_Name">
        '''''
        '''''
        ''''' resourceName
        '''''ViRsrc
        '''''Specifies the resourceName assigned by Measurement &amp; Automation
        '''''          Explorer (MAX), for example &quot;PXI1Slot3&quot; where &quot;PXI1Slot3&quot; is an
        '''''          instrument's resourceName. resourceName can also be a logical IVI
        '''''          name.</table>
        '''''
        '''''</param>
        '''''<param name="ID_Query">
        '''''
        ''''' IDQuery
        '''''ViBoolean
        '''''Specifies whether the device is queried to determine if the device is a valid instrument for NI-DCPower.
        '''''
        '''''
        '''''
        '''''Defined Values:
        '''''
        '''''
        '''''VI_TRUE (1) Perform ID query.VI_FALSE (0)Do not perform ID query.
        '''''
        '''''Default Value: VI_TRUE
        '''''
        '''''
        '''''</param>
        '''''<param name="Reset_Device">
        ''''' 
        ''''' resetDevice
        '''''ViBoolean
        '''''Specifies whether to reset the device during the initialization procedure.
        '''''
        '''''
        '''''
        '''''Defined Values:
        '''''
        '''''
        '''''VI_TRUE (1) Reset the device.VI_FALSE (0)Do not reset the device.
        '''''
        '''''Default Value: VI_TRUE
        '''''
        '''''
        '''''</param>
        '''''<param name="Instrument_Handle">
        '''''
        ''''' vi
        '''''ViSession
        '''''Returns a session handle that you use to identify the session in all subsequent NI-DCPower function calls.</table>
        '''''
        '''''</param>
        Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean)
            MyBase.New()
            Dim pInvokeResult As Integer = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Me._disposed = False
        End Sub

        '''''<summary>
        '''''
        '''''niDCPower_InitExtCal
        '''''
        '''''
        ''''' ViStatus niDCPower_InitExtCal (ViRsrc resourceName,
        '''''                                     ViConstString password,
        '''''                                     ViSession *newVi);
        ''''' Purpose
        '''''If password is valid, this function creates a new IVI instrument driver
        '''''      session to the device specified in resourceName and returns an
        '''''      instrument handle you use to identify the device in all subsequent
        '''''      NI-DCPower function calls. This function also sends initialization
        '''''      commands to set the device to the state necessary for the operation
        '''''      of NI-DCPower.
        '''''      
        '''''      Opening a calibration session always performs a reset. Refer to the calibration procedure for the device 
        '''''  you are calibrating for detailed instructions on the appropriate use of this function.
        '''''
        '''''</summary>
        '''''<param name="Resource_Name">
        '''''
        ''''' resourceName
        '''''ViRsrc
        '''''Specifies the resourceName assigned by Measurement &amp; Automation
        '''''          Explorer (MAX), for example &quot;PXI1Slot3&quot; where &quot;PXI1Slot3&quot; is an
        '''''          instrument's resourceName. resourceName can also be a logical IVI
        '''''          name.     </table>
        '''''
        '''''</param>
        '''''<param name="Password">
        '''''
        ''''' password
        '''''ViConstString
        '''''Specifies the password for opening a calibration session. The initial password is factory configured to "NI".  password can be a maximum of four alphanumeric characters.</table>
        '''''
        '''''</param>
        '''''<param name="Instrument_Handle">
        ''''' 
        '''''
        ''''' newVi
        '''''ViSession*
        '''''Returns a handle that you use to identify the session in all subsequent NI-DCPower function calls.</table>
        '''''
        '''''</param>
        Public Sub New(ByVal Resource_Name As String, ByVal Password As String)
            MyBase.New()
            Dim pInvokeResult As Integer = PInvoke.InitExtCal(Resource_Name, Password, Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Me._disposed = False
        End Sub

        '''''<summary>
        '''''
        '''''niDCPower_InitWithOptions
        '''''
        ''''' ViStatus niDCPower_InitWithOptions (ViRsrc resourceName,
        '''''                                          ViBoolean IDQuery,
        '''''                                          ViBoolean resetDevice,
        '''''                                          ViString optionString,
        '''''                                          ViSession *newVi);
        ''''' Purpose
        '''''Creates a new IVI instrument driver session to the device specified in resourceName and returns a session handle you use to identify the device in all subsequent NI-DCPower function calls. With this function, you can optionally set the initial state of the following session attributes: 
        ''''' NIDCPOWER_ATTR_SIMULATE
        '''''  NIDCPOWER_ATTR_DRIVER_SETUP
        '''''  NIDCPOWER_ATTR_RANGE_CHECK
        '''''  NIDCPOWER_ATTR_QUERY_INSTRUMENT_STATUS
        ''''' NIDCPOWER_ATTR_CACHE
        '''''  NIDCPOWER_ATTR_RECORD_COERCIONS
        '''''
        '''''
        '''''This function also sends initialization commands to set the device to the state necessary for NI-DCPower to operate.
        '''''
        '''''To place the device in a known start-up state when creating a new session, set resetDevice to VI_TRUE. This action is equivalent to using the niDCPower_reset function.
        '''''
        '''''To open a session and leave the device in its existing configuration without passing through a transitional output state, set resetDevice to VI_FALSE, and immediately call the niDCPower_Abort function. To apply a new configuration without disrupting the output channels of the device, configure the device in Delayed Configuration mode as in the previous session changing only the desired settings, and then call the niDCPower_Initiate function.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Resource_Name">
        '''''
        ''''' resourceName
        '''''ViRsrc
        '''''Specifies the resourceName assigned by Measurement &amp; Automation Explorer (MAX), for example &quot;PXI1Slot3&quot; where &quot;PXI1Slot3&quot; is an instrument's resourceName. resourceName can also be a logical IVI name.</table>
        '''''
        '''''</param>
        '''''<param name="ID_Query">
        '''''
        ''''' IDQuery
        '''''ViBoolean
        '''''Specifies whether the device is queried to determine if the device is a valid instrument for NI-DCPower. The default value is VI_TRUE.
        '''''
        '''''</table>
        '''''
        '''''</param>
        '''''<param name="Reset_Device">
        '''''
        ''''' resetDevice
        '''''ViBoolean
        '''''Specifies whether to reset the device during the initialization procedure. The default value is VI_TRUE.
        '''''
        '''''
        '''''
        '''''</table>
        '''''
        '''''</param>
        '''''<param name="Option_String">
        '''''
        ''''' optionString
        '''''ViString
        '''''Specifies the initial value of certain attributes for the session. The syntax for optionString is a list of attributes with an assigned value where 1 is VI_TRUE and 0 is VI_FALSE. Each attribute/value combination is delimited with a comma, as shown in the following example: 
        '''''&quot;Simulate=0,RangeCheck=1,QueryInstrStatus=0,Cache=1&quot;If you do not wire this input or pass an empty string, the session assigns the default values, shown in the example, for these attributes. You do not have to specify a value for all the attributes. If you do not specify a value for an attribute, the default value is used. 
        '''''
        '''''<p>For more information about simulating a device, refer to  Simulating a Power Supply or SMU. </table>
        '''''
        '''''</param>
        '''''<param name="Instrument_Handle">
        '''''
        ''''' newVi
        '''''ViSession*
        '''''Returns a handle that you use to identify the device in all subsequent NI-DCPower function calls.</table>
        '''''
        '''''</param>
        Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean, ByVal Option_String As String)
            MyBase.New()
            Dim pInvokeResult As Integer = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Option_String, Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Me._disposed = False
        End Sub

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ConfigureOutputEnabled
        '''''
        '''''
        ''''' ViStatus niDCPower_ConfigureOutputEnabled (ViSession vi,
        '''''                                                 ViConstString channelName,
        '''''                                                 ViBoolean enabled);
        ''''' Purpose
        '''''Enables or disables generation on the specified  channel(s).  Depending on the selected output function, the voltage level or the current level must be set in addition to enabling the output to generate the desired level.  Refer to the niDCPower_ConfigureVoltageLevel function, the niDCPower_ConfigureCurrentLevel function, and the niDCPower_ConfigureOutputFunction function for more information about configuring the desired output level.
        '''''
        '''''
        '''''Note&#160;&#160;If the device is in Delayed Configuration mode, enabling the output will not take effect until you call the niDCPower_Initiate function.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify multiple 
        '''''channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). 
        '''''A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, 
        '''''multiple output channel configurations are performed sequentially based on the order specified in this parameter. 
        '''''
        '''''</param>
        '''''<param name="Enabled">
        '''''
        ''''' enabled
        '''''ViBoolean
        '''''Specifies whether the output is enabled or disabled.
        '''''
        '''''
        '''''
        '''''Defined Values:
        '''''
        '''''VI_TRUEEnables generation on the specified output channel(s).
        '''''VI_FALSEDisables generation on the specified output channel(s).
        '''''
        '''''
        '''''
        '''''Default Value: VI_TRUE
        '''''</param>
        Public Function ConfigureOutputEnabled(ByVal Channel_Name As String, ByVal Enabled As Boolean) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureOutputEnabled(Me._handle, Channel_Name, System.Convert.ToUInt16(Enabled))
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_ConfigureOutputFunction
        '''''
        '''''
        ''''' ViStatus niDCPower_ConfigureOutputFunction (ViSession vi,
        '''''                                                 ViConstString channelName,
        '''''                                                 ViBoolean function);
        ''''' Purpose
        '''''Configures the function the device attempts to generate for the specified channel(s).
        '''''
        '''''
        '''''When NIDCPOWER_VAL_DC_VOLTAGE is selected, the device generates the desired voltage level on the output as long as the output current is below the current limit. The following functions can be used to configure the channel when NIDCPOWER_VAL_DC_VOLTAGE is selected:
        '''''niDCPower_ConfigureVoltageLevel
        '''''niDCPower_ConfigureCurrentLimit
        '''''
        '''''niDCPower_ConfigureVoltageLevelRange
        '''''
        '''''niDCPower_ConfigureCurrentLimitRange
        '''''
        '''''When NIDCPOWER_VAL_DC_CURRENT is selected, the device generates the desired current level on the output as long as the output voltage is below the voltage limit.  The following functions can be used to configure the channel when NIDCPOWER_VAL_DC_CURRENT is selected:
        '''''niDCPower_ConfigureCurrentLevel
        '''''
        '''''niDCPower_ConfigureVoltageLimit
        '''''
        '''''niDCPower_ConfigureCurrentLevelRange
        '''''
        '''''niDCPower_ConfigureVoltageLimitRange
        '''''
        '''''</p>
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify multiple 
        '''''channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). 
        '''''A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, 
        '''''multiple output channel configurations are performed sequentially based on the order specified in this parameter. 
        '''''
        '''''</param>
        '''''<param name="Function">
        '''''
        ''''' function
        '''''ViInt32
        '''''Configures the function to generate for the specified channel(s).
        '''''
        '''''
        '''''
        '''''Defined Values:
        '''''
        '''''NIDCPOWER_VAL_DC_VOLTAGESets the output function to DC voltage.
        '''''NIDCPOWER_VAL_DC_CURRENTSets the output function to DC current.
        '''''
        '''''
        '''''Default Value: NIDCPOWER_VAL_DC_VOLTAGE
        '''''
        '''''
        '''''
        '''''</param>
        Public Function ConfigureOutputFunction(ByVal Channel_Name As String, ByVal [Function] As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureOutputFunction(Me._handle, Channel_Name, [Function])
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_MeasureMultiple
        '''''
        '''''
        ''''' ViStatus niDCPower_MeasureMultiple (ViSession vi,
        '''''                                              ViConstString channelName,
        '''''                                              ViReal64 voltageMeasurements[],
        '''''                                              ViReal64 currentMeasurements[]);
        ''''' Purpose
        '''''Returns arrays of the measured voltage and current values
        '''''      on the specified output channel(s). Each call to this function
        '''''      blocks other function calls until the measurements are returned from the
        '''''      device. The order of the measurements returned in the array corresponds to the
        '''''      order on the specified output channel(s). The measurement speed of the device and the NIDCPOWER_ATTR_SAMPLES_TO_AVERAGE attribute
        '''''  dictates the length of time that a measurement takes.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies the output channels to measure. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2).</table>
        '''''
        '''''</param>
        '''''<param name="Voltage_Measurements">
        '''''
        ''''' voltageMeasurements
        '''''ViReal64[]
        '''''Returns an array of voltage measurements. The measurements in the array are returned in the same order as the channels specified in channelName. Ensure that sufficient space has been allocated for the returned array.</table>
        '''''
        '''''</param>
        '''''<param name="Current_Measurements">
        '''''
        ''''' currentMeasurements
        '''''ViReal64[]
        '''''Returns an array of current measurements. The measurements in the array are returned in the same order as the channels specified in channelName. Ensure that sufficient space has been allocated for the returned array.</table>
        '''''
        '''''</param>
        Public Function MeasureMultiple(ByVal Channel_Name As String, ByVal Voltage_Measurements() As Double, ByVal Current_Measurements() As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.MeasureMultiple(Me._handle, Channel_Name, Voltage_Measurements, Current_Measurements)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ConfigureSense
        '''''
        '''''
        ''''' ViStatus niDCPower_ConfigureSense (ViSession vi,
        '''''                                                 ViConstString channelName,
        '''''                                                 ViBoolean sense);
        ''''' Purpose
        '''''Specifies whether to use local or remote sensing of the output voltage on the specified channel(s).  Refer to the Devices topic specific to your device in the NI DC Power Supplies and SMUs Help to find out more information about sensing on supported channels.  
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify multiple 
        '''''channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). 
        '''''A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, 
        '''''multiple output channel configurations are performed sequentially based on the order specified in this parameter. 
        '''''
        '''''</param>
        '''''<param name="Sense">
        '''''
        '''''
        ''''' sense
        '''''ViInt32
        ''''' Specifies local or remote sensing on the specified channel(s).
        '''''
        '''''
        '''''
        '''''Defined Values:
        '''''
        '''''NIDCPOWER_VAL_LOCALLocal sensing NIDCPOWER_VAL_REMOTERemote sensing
        '''''
        '''''
        '''''
        '''''Default Value: NIDCPOWER_VAL_LOCAL
        '''''
        '''''</param>
        Public Function ConfigureSense(ByVal Channel_Name As String, ByVal Sense As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSense(Me._handle, Channel_Name, Sense)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_Initiate
        '''''
        '''''
        ''''' ViStatus niDCPower_Initiate (ViSession vi);
        ''''' Purpose
        '''''Commits the configured settings to hardware and places the device in
        '''''       Immediate mode. Any configuration calls made after this function are applied immediately. To commit simultaneous hardware settings on
        '''''      multiple output channels, call the niDCPower_Abort function, configure the power
        '''''      supply, and call this function.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        Public Function Initiate() As Integer
            Dim pInvokeResult As Integer = PInvoke.Initiate(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_Abort
        '''''
        '''''
        ''''' ViStatus niDCPower_Abort (ViSession vi);
        ''''' Purpose
        '''''Places the device in  Delayed Configuration mode. Any
        '''''      configuration functions called after this function are not
        '''''      applied until the niDCPower_Initiate function is called. If power output
        '''''      is enabled when you call the niDCPower_Abort function, the output channels remain
        '''''      in their current state and continue providing power.Use the niDCPower_ConfigureOutputEnabled function to disable power output
        '''''      on a per channel basis. Use the niDCPower_reset function to disable
        '''''      output on all channels. While in Delayed Configuration mode, NI-DCPower performs only generic parameter validation. Any conflicting configuration calls
        '''''      are not validated until the niDCPower_Initiate function is called. If the
        '''''      same configuration is set multiple times to different values, NI-DCPower uses the last configuration call.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        Public Function Abort() As Integer
            Dim pInvokeResult As Integer = PInvoke.Abort(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ConfigureVoltageLevel
        '''''
        '''''
        ''''' ViStatus niDCPower_ConfigureVoltageLevel (ViSession vi,
        '''''                                                ViConstString channelName,
        '''''                                                ViReal64 level);
        ''''' Purpose
        '''''Configures the voltage level the device attempts to generate for the specified channel(s). The channel must be enabled for the specified voltage level to take effect.  Refer to the niDCPower_ConfigureOutputEnabled attribute for more information about enabling the output channel.
        '''''
        '''''
        '''''The voltage level setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_VOLTAGE output function using the niDCPower_ConfigureOutputFunction function.  The device actively regulates the voltage at the specified level unless doing so causes a current output greater than the current limit through the channels' output terminals.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        '''''of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        '''''
        '''''</param>
        '''''<param name="Level">
        '''''
        ''''' level
        '''''ViReal64
        ''''' Specifies the voltage level, in volts, for the output channel generation. 
        '''''
        '''''
        '''''
        '''''
        '''''Valid Values:
        '''''
        '''''The valid values for this parameter are defined by the voltage level range that is selected using the niDCPower_ConfigureVoltageLevelRange function.
        '''''
        '''''</param>
        Public Function ConfigureVoltageLevel(ByVal Channel_Name As String, ByVal Level As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureVoltageLevel(Me._handle, Channel_Name, Level)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ConfigureVoltageLevelRange
        '''''
        '''''
        ''''' ViStatus niDCPower_ConfigureVoltageLevel Range(ViSession vi,
        '''''                                                ViConstString channelName,
        '''''                                                ViReal64 range);
        ''''' Purpose
        '''''Configures the voltage level range for the specified channel(s).  The configured range defines the valid values the voltage level can be set to using the niDCPower_ConfigureVoltageLevel function.  
        '''''
        '''''The voltage level range setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_VOLTAGE output function using the niDCPower_ConfigureOutputFunction function. 
        '''''     
        '''''Use the NIDCPOWER_ATTR_VOLTAGE_LEVEL_AUTORANGE attribute to enable automatic selection of the voltage level range. 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        '''''of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        '''''
        '''''</param>
        '''''<param name="Range">
        '''''
        '''''
        ''''' range
        '''''ViReal64
        '''''Specifies the voltage level range, in volts, on the specified channel(s).
        '''''
        '''''
        '''''
        '''''
        '''''
        '''''Valid Values:
        '''''
        '''''
        '''''NI PXI-4110
        '''''ChannelVoltage Level Range (V)Voltage Level (V)
        '''''060 to +6
        '''''1200 to +20
        '''''2200 to -20
        '''''
        '''''
        '''''NI PXI-4130
        '''''
        '''''ChannelVoltage Level Range (V)Voltage Level (V)
        '''''060 to +6
        '''''16-6 to +6
        '''''20-20 to +20
        '''''
        '''''Note&#160;&#160;  If a range other than what is listed in the preceding table is selected, it will be coerced to the next-highest range.  For example, requesting the 10 V voltage level range on Channel 1 on the NI-PXI 4130 coerces the voltage level range to 20 V.  Refer to the Ranges topic in the NI DC Power Supplies and SMUs Help for more information about coercion.
        '''''
        '''''
        '''''
        '''''
        '''''</param>
        Public Function ConfigureVoltageLevelRange(ByVal Channel_Name As String, ByVal Range As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureVoltageLevelRange(Me._handle, Channel_Name, Range)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ConfigureCurrentLimit
        '''''
        '''''
        ''''' ViStatus niDCPower_ConfigureCurrentLimit (ViSession vi,
        '''''                                                ViConstString channelName,
        '''''                                                ViInt32 behavior,
        '''''                                                ViReal64 limit);
        ''''' Purpose
        '''''Configures the current limit for the specified channel(s).
        '''''      The channel must be enabled for the specified current limit to take effect. Refer to
        '''''      the niDCPower_ConfigureOutputEnabled function for more information about enabling the output channel.
        '''''
        '''''
        '''''
        '''''The current limit is the current that the output should not exceed when generating the desired voltage level.  The current limit setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_VOLTAGE output function using the niDCPower_ConfigureOutputFunction function.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify 
        '''''multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        '''''of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a 
        '''''hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this 
        '''''parameter.
        '''''
        '''''</param>
        '''''<param name="Behavior">
        '''''
        ''''' behavior
        '''''ViInt32
        '''''Specifies how the output should behave when the current limit is
        '''''          reached.
        '''''
        '''''
        '''''          Defined Values:
        '''''
        '''''          NIDCPOWER_VAL_CURRENT_REGULATEControls output current so that it does not exceed the current limit.  Power continues to generate even if the current limit is reached.
        '''''          
        '''''          
        '''''
        '''''</param>
        '''''<param name="Limit">
        '''''
        ''''' limit
        '''''ViReal64
        '''''Specifies the current limit, in amps, on the specified channel(s).
        '''''
        '''''
        '''''
        '''''
        '''''
        '''''Valid Values:
        '''''
        '''''The valid values for this parameter are defined by the current limit range that is configured using the niDCPower_ConfigureCurrentLimitRange function.
        '''''
        '''''
        '''''
        '''''
        '''''
        '''''
        '''''
        '''''</param>
        Public Function ConfigureCurrentLimit(ByVal Channel_Name As String, ByVal Behavior As Integer, ByVal Limit As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureCurrentLimit(Me._handle, Channel_Name, Behavior, Limit)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ConfigureCurrentLimitRange
        '''''
        '''''
        ''''' ViStatus niDCPower_ConfigureCurrentLimit Range(ViSession vi,
        '''''                                                ViConstString channelName,
        '''''                                                ViReal64 range);
        ''''' Purpose
        '''''Configures the current limit range for the specified 
        '''''      channel(s).The configured range defines the valid values  the current limit can be set to using the niDCPower_ConfigureCurrentLimit function. The current limit range setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_VOLTAGE output function using the niDCPower_ConfigureOutputFunction function. 
        '''''Use the NIDCPOWER_ATTR_CURRENT_LIMIT_AUTORANGE attribute to enable automatic selection of the current limit range.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        '''''of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        '''''
        '''''</param>
        '''''<param name="Range">
        '''''
        '''''
        ''''' range
        '''''ViReal64
        '''''Specifies the current limit range, in amps, for the specified channel.
        '''''
        '''''
        '''''
        '''''Valid Values:
        '''''
        '''''
        '''''NI PXI-4110
        '''''ChannelCurrent Limit RangeCurrent Limit
        '''''01 A+0.01 to +1 A
        '''''1, 220 mA+0.20 to +20 mA
        '''''1 A+0.01 to +1 A
        '''''
        '''''
        '''''NI PXI-4130
        '''''ChannelCurrent Limit RangeCurrent Limit
        '''''01 A+0.02 to +1 A
        '''''1200 &#956;A +4 to +200 &#956;A
        '''''2 mA+0.04 to +2 mA
        '''''20 mA+0.40 to +20 mA
        '''''200 mA+4 to +200 mA
        '''''2 A+0.04 to +2 A
        '''''
        '''''
        '''''Note&#160;&#160;  If a range other than what is listed in the preceding table is selected, it will be coerced to the next-highest range.  For example, requesting the 100 mA current limit range on Channel 1 on the NI-PXI 4130 coerces the current level range to 200 mA.  Refer to the Ranges topic in the NI DC Power Supplies and SMUs Help for more information about coercion.
        '''''
        '''''
        '''''
        '''''
        '''''</param>
        Public Function ConfigureCurrentLimitRange(ByVal Channel_Name As String, ByVal Range As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureCurrentLimitRange(Me._handle, Channel_Name, Range)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ConfigureCurrentLevel
        '''''
        '''''
        ''''' ViStatus niDCPower_ConfigureCurrentLevel (ViSession vi,
        '''''                                                ViConstString channelName,
        '''''                                                ViReal64 level);
        ''''' Purpose
        '''''Configures the current level the device attempts to generate for the specified 
        '''''      channel(s). The channel must be enabled for the specified current level to take effect.  Refer to the niDCPower_ConfigureOutputEnabled function for more information about enabling the output channel.  
        '''''
        '''''The current level setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_CURRENT output function using the niDCPower_ConfigureOutputFunction function.  The device actively regulates the current at the specified level unless doing so causes a voltage greater than the voltage limit across the channels' output terminals.
        '''''    
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        '''''of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        '''''
        '''''</param>
        '''''<param name="Level">
        '''''
        ''''' level
        '''''ViReal64
        '''''Specifies the current level, in amps, to generate for the specified channel(s).
        '''''
        '''''
        '''''
        '''''
        '''''Valid Values:
        '''''
        '''''The valid values for this parameter are defined by the current level range that is configured using the niDCPower_ConfigureCurrentLevelRange function.
        '''''
        '''''
        '''''
        '''''
        '''''
        '''''</param>
        Public Function ConfigureCurrentLevel(ByVal Channel_Name As String, ByVal Level As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureCurrentLevel(Me._handle, Channel_Name, Level)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ConfigureCurrentLevelRange
        '''''
        '''''
        ''''' ViStatus niDCPower_ConfigureCurrentLevelRange (ViSession vi,
        '''''                                                ViConstString channelName,
        '''''                                                ViReal64 range);
        ''''' Purpose
        '''''Configures the current level range for the specified 
        '''''      channel(s).  The configured range defines the valid values the current level can be set to using the niDCPower_ConfigureCurrentLevel function.  The current level range setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_CURRENT output function using the niDCPower_ConfigureOutputFunction function. 
        '''''
        '''''Use the NIDCPOWER_ATTR_CURRENT_LEVEL_AUTORANGE attribute to enable automatic selection of the current level range. 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        '''''of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        '''''
        '''''</param>
        '''''<param name="Range">
        '''''
        ''''' range
        '''''ViReal64
        '''''Specifies the current level range, in amps,  for the specified channel.
        '''''
        '''''
        '''''
        '''''
        '''''
        '''''Valid Values:
        '''''
        '''''
        '''''NI PXI-4110
        '''''
        '''''ChannelCurrent Level RangeCurrent Level
        '''''01 A+0.01 to +1 A
        '''''120 mA+0.20 to +20 mA
        '''''1 A+0.01 to +1 A
        '''''220 mA-0.20 to -20 mA
        '''''1 A-0.01 to -1 A
        '''''
        '''''
        '''''NI PXI-4130
        '''''
        '''''ChannelCurrent Level RangeCurrent Level
        '''''01 A+0.02 to +1 A
        '''''1200 &#956;A +4 to +200 &#956;A and -4 to -200 &#956;A
        '''''2 mA+0.04 to +2 mA and -0.04 to -2 mA
        '''''20 mA+0.40 to +20 mA and -0.40 to -20 mA
        '''''200 mA+4 to +200 mA and -4 to -200 mA
        '''''2 A+0.04 to +2 A and -0.04 to -2 A
        '''''
        '''''Note&#160;&#160;  If a range other than what is listed in the preceding table is selected, it will be coerced to the next-highest range.  For example, requesting the 100 mA current level range on Channel 1 on the NI-PXI 4130 coerces the current level range to 200 mA.  Refer to the Ranges topic in the NI DC Power Supplies and SMUs Help for more information about coercion.
        '''''
        '''''</param>
        Public Function ConfigureCurrentLevelRange(ByVal Channel_Name As String, ByVal Range As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureCurrentLevelRange(Me._handle, Channel_Name, Range)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ConfigureVoltageLimit
        '''''
        '''''
        ''''' ViStatus niDCPower_ConfigureVoltageLimit (ViSession vi,
        '''''                                                ViConstString channelName,
        '''''                                                ViReal64 limit);
        ''''' Purpose
        '''''Configures the voltage limit for the specified channel(s). The channel must be enabled for the specified voltage limit to take effect.
        '''''      Refer to the niDCPower_ConfigureOutputEnabled function for more information about enabling the output channel.
        '''''
        '''''The voltage limit is the voltage that the output should not exceed when generating the desired current level.   The voltage limit setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_CURRENT output function using the niDCPower_ConfigureOutputFunction function. 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        '''''of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        '''''
        '''''</param>
        '''''<param name="Limit">
        '''''
        ''''' limit
        '''''ViReal64
        '''''Specifies the voltage limit, in volts, on the specified output channel(s).
        '''''
        '''''
        '''''
        '''''
        '''''Valid Values:
        '''''
        '''''The valid values for this parameter are defined by the voltage limit range that is configured using the  niDCPower_ConfigureVoltageLimitRange function.
        '''''
        '''''
        '''''
        '''''
        '''''</param>
        Public Function ConfigureVoltageLimit(ByVal Channel_Name As String, ByVal Limit As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureVoltageLimit(Me._handle, Channel_Name, Limit)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ConfigureVoltageLimitRange
        '''''
        '''''
        ''''' ViStatus niDCPower_ConfigureVoltageLimitRange (ViSession vi,
        '''''                                                ViConstString channelName,
        '''''                                                ViReal64 range);
        ''''' Purpose
        '''''Configures the voltage limit range for the specified
        '''''      channel(s). The configured range defines the valid values the voltage limit can be set to using the niDCPower_ConfigureVoltageLimit function.
        '''''     The voltage limit range setting is applicable only if the channel is set to the NIDCPOWER_VAL_DC_CURRENT output function using the niDCPower_ConfigureOutputFunction function. 
        '''''Use the NIDCPOWER_ATTR_VOLTAGE_LIMIT_AUTORANGE attribute to enable automatic selection of the voltage limit range.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        '''''of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        '''''
        '''''</param>
        '''''<param name="Range">
        '''''
        ''''' range
        '''''ViReal64
        '''''Specifies the voltage limit range, in volts, on the specified channel(s).
        '''''
        '''''
        '''''
        '''''
        '''''
        '''''
        '''''Valid Values:
        '''''
        '''''
        '''''NI PXI-4110
        '''''ChannelVoltage Limit Range (V)Voltage Limit (V)
        '''''060 to +6
        '''''1, 2200 to +20
        '''''
        '''''
        '''''
        '''''NI PXI-4130
        '''''ChannelVoltage Limit Range (V)Voltage Limit (V)
        '''''060 to +6
        '''''160 to +6
        '''''200 to +20
        '''''
        '''''
        '''''Note&#160;&#160;  If a range other than what is listed in the preceding table is selected, it will be coerced to the next-highest range.  For example, requesting the 10 V voltage limit range on Channel 1 on the NI-PXI 4130 coerces the voltage limit range to 20 V.  Refer to the Ranges topic in the NI DC Power Supplies and SMUs Help for more information about coercion.
        '''''
        '''''
        '''''</param>
        Public Function ConfigureVoltageLimitRange(ByVal Channel_Name As String, ByVal Range As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureVoltageLimitRange(Me._handle, Channel_Name, Range)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        ''''' 
        '''''niDCPower_QueryOutputState
        '''''
        ''''' ViStatus niDCPower_QueryOutputState (ViSession vi,
        '''''                                           ViConstString channelName,
        '''''                                           ViInt32 outputState,
        '''''                                           ViBoolean  *inState);
        ''''' Purpose
        '''''Queries the specified output channel to determine if the output channel is currently in the state specified by outputState.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies the output channel to query.  The output state may only be queried for one channel at a time.</table>
        '''''
        '''''</param>
        '''''<param name="Output_State">
        ''''' 
        ''''' outputState
        '''''ViInt32
        '''''Specifies the outputState of the output channel that is being queried.
        '''''
        '''''
        '''''Defined Values:
        '''''NIDCPOWER_VAL_OUTPUT_CONSTANT_VOLTAGEThe device maintains a constant
        '''''          voltage by adjusting the current.
        '''''  NIDCPOWER_VAL_OUTPUT_CONSTANT_CURRENTThe device maintains a constant
        '''''          current by adjusting the voltage.
        '''''
        '''''
        '''''Default Value: NIDCPOWER_VAL_OUTPUT_CONSTANT_VOLTAGE
        '''''</param>
        '''''<param name="In_State">
        '''''
        ''''' inState
        '''''ViBoolean*
        '''''Returns whether the device output channel is in the specified state.</table>
        '''''
        '''''</param>
        Public Function QueryOutputState(ByVal Channel_Name As String, ByVal Output_State As Integer, ByRef In_State As Boolean) As Integer
            Dim In_StateAsUShort As UShort
            Dim pInvokeResult As Integer = PInvoke.QueryOutputState(Me._handle, Channel_Name, Output_State, In_StateAsUShort)
            In_State = System.Convert.ToBoolean(In_StateAsUShort)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        ''''' 
        '''''niDCPower_QueryInCompliance
        '''''
        ''''' ViStatus niDCPower_QueryInCompliance(ViSession vi,
        '''''                                           ViConstString channelName,
        '''''                                           
        '''''                                           ViBoolean *inCompliance);
        ''''' Purpose
        '''''Queries the device to indicate if the output is operating at the compliance limit.
        '''''
        '''''The compliance limit is the current limit when the output function is set to NIDCPOWER_VAL_DC_VOLTAGE.  If the output is operating at the compliance limit, the output reaches the current limit before the desired voltage level.  Refer to the niDCPower_ConfigureOutputFunction function and the niDCPower_ConfigureCurrentLimit function for more information about output function and current limit, respectively.
        '''''
        '''''The compliance limit is the voltage limit when the output function is set to NIDCPOWER_VAL_DC_CURRENT.  If the output is operating at the compliance limit, the output reaches the voltage limit before the desired current level.  Refer to the niDCPower_ConfigureOutputFunction function and the niDCPower_ConfigureVoltageLimit function for more information about output function and voltage limit, respectively.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies the output channel to query. Compliance status can only be queried for one channel at a time.</table>
        '''''
        '''''</param>
        '''''<param name="In_Compliance">
        '''''
        ''''' inCompliance
        '''''ViBoolean*
        '''''Returns whether the device output channel is in compliance.</table>
        '''''
        '''''</param>
        Public Function QueryInCompliance(ByVal Channel_Name As String, ByRef In_Compliance As Boolean) As Integer
            Dim In_ComplianceAsUShort As UShort
            Dim pInvokeResult As Integer = PInvoke.QueryInCompliance(Me._handle, Channel_Name, In_ComplianceAsUShort)
            In_Compliance = System.Convert.ToBoolean(In_ComplianceAsUShort)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_Measure
        '''''
        '''''
        ''''' ViStatus niDCPower_Measure (ViSession vi,
        '''''                                  ViConstString channelName,
        '''''                                  ViInt32 measurementType,
        '''''                                  ViReal64 *measurement)
        ''''' Purpose
        '''''Returns the measured value of either the voltage or current on the specified output channel. Each call to this function blocks
        '''''      other function calls until the hardware returns the measurement.
        '''''      The measurement speed of the device and the NIDCPOWER_ATTR_SAMPLES_TO_AVERAGE
        '''''      attribute dictate the length of time that a measurement takes. To measure multiple output channels, use the 
        '''''      niDCPower_MeasureMultiple function.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies the output channel to measure.  Only one channel can be measured at a time with this function.  Use the niDCPower_MeasureMultiple function to measure multiple channels.</table>
        '''''
        '''''</param>
        '''''<param name="Measurement_Type">
        '''''
        ''''' measurementType
        '''''ViInt32
        '''''Specifies whether a voltage or current value should be measured.
        '''''
        '''''
        '''''Defined Values:
        '''''
        '''''
        '''''NIDCPOWER_VAL_MEASURE_VOLTAGEThe device measures voltage. NIDCPOWER_VAL_MEASURE_CURRENTThe device measures current.
        '''''
        '''''Default Value: NIDCPOWER_VAL_MEASURE_VOLTAGE
        '''''</table>
        '''''</param>
        '''''<param name="Measurement">
        '''''
        ''''' measurement
        '''''ViReal64*
        '''''Returns the value of the measurement, either in volts for voltage or
        '''''          amps for current.</table>
        '''''
        '''''</param>
        Public Function Measure(ByVal Channel_Name As String, ByVal Measurement_Type As Integer, ByRef Measurement As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.Measure(Me._handle, Channel_Name, Measurement_Type, Measurement)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_QueryMaxCurrentLimit
        '''''
        '''''
        ''''' ViStatus niDCPower_QueryMaxCurrentLimit (ViSession vi,
        '''''                                               ViConstString channelName,
        '''''                                               ViReal64 voltageLevel,
        '''''                                               ViReal64 *maxCurrentLimit);
        ''''' Purpose
        '''''Queries the maximum current limit on an output channel if the output channel is set to the specified voltageLevel.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies the output channel to query.  The maximum current limit may only be queried for one channel at a time.</table>
        '''''
        '''''</param>
        '''''<param name="Voltage_Level">
        '''''
        ''''' voltageLevel
        '''''ViReal64
        '''''Specifies the voltage level to use when calculating the maxCurrentLimit.</table>
        '''''
        '''''</param>
        '''''<param name="Max_Current_Limit">
        '''''
        ''''' maxCurrentLimit
        '''''ViReal64*
        '''''Returns the maximum current limit that can be set with the specified
        '''''          voltageLevel.</table>
        '''''
        '''''</param>
        Public Function QueryMaxCurrentLimit(ByVal Channel_Name As String, ByVal Voltage_Level As Double, ByRef Max_Current_Limit As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.QueryMaxCurrentLimit(Me._handle, Channel_Name, Voltage_Level, Max_Current_Limit)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        ''''' 
        '''''niDCPower_QueryMaxVoltageLevel
        '''''
        '''''
        ''''' ViStatus niDCPower_QueryMaxVoltageLevel (ViSession vi,
        '''''                                               ViConstString channelName,
        '''''                                               ViReal64 currentLimit,
        '''''                                               ViReal64 *maxVoltageLevel);
        ''''' Purpose
        '''''Queries the maximum voltage level on an output channel if the output channel is set to the specified currentLimit.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies the output channel to query.  The maximum voltage level may only be queried for one channel at a time.</table>
        '''''
        '''''</param>
        '''''<param name="Current_Limit">
        '''''
        ''''' currentLimit
        '''''ViReal64
        '''''Specifies the current limit to use when calculating the maxVoltageLevel.</table>
        '''''
        '''''</param>
        '''''<param name="Max_Voltage_Level">
        '''''
        ''''' maxVoltageLevel
        '''''ViReal64*
        '''''Returns the maximum voltage level that can be set on an output channel with the specified
        '''''          currentLimit.</table>
        '''''
        '''''</param>
        Public Function QueryMaxVoltageLevel(ByVal Channel_Name As String, ByVal Current_Limit As Double, ByRef Max_Voltage_Level As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.QueryMaxVoltageLevel(Me._handle, Channel_Name, Current_Limit, Max_Voltage_Level)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_QueryMinCurrentLimit
        '''''
        '''''
        ''''' ViStatus niDCPower_QueryMinCurrentLimit (ViSession vi,
        '''''                                               ViConstString channelName,
        '''''                                               ViReal64 voltageLevel,
        '''''                                               ViReal64 *minCurrentLimit);
        ''''' Purpose
        '''''Queries the minimum current limit on an output channel if the output channel is set to the specified voltageLevel.
        '''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies the output channel to query. The minimum current limit may only be queried for one channel at a time.</table>
        '''''
        '''''</param>
        '''''<param name="Voltage_Level">
        '''''
        ''''' voltageLevel
        '''''ViReal64
        '''''Specifies the voltage level to use when calculating the minCurrentLimit.</table>
        '''''
        '''''</param>
        '''''<param name="Min_Current_Limit">
        '''''
        ''''' minCurrentLimit
        '''''ViReal64*
        '''''Returns the minimum current limit that can be set on an output channel with the specified voltageLevel.</table>
        '''''
        '''''</param>
        Public Function QueryMinCurrentLimit(ByVal Channel_Name As String, ByVal Voltage_Level As Double, ByRef Min_Current_Limit As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.QueryMinCurrentLimit(Me._handle, Channel_Name, Voltage_Level, Min_Current_Limit)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_CloseExtCal
        '''''
        '''''
        ''''' ViStatus niDCPower_CloseExtCal (ViSession vi,
        '''''                                      ViInt32 action);
        ''''' Purpose
        '''''Closes the session specified in vi and deallocates
        '''''      the resources that NI-DCPower reserved for calibration. Refer to the calibration
        '''''      procedure for the device you are calibrating for detailed instructions on the
        '''''      appropriate use of this function. If an error occurs before this
        '''''      function, action defaults to NIDCPOWER_VAL_CANCEL.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''
        ''''' vi
        '''''ViSession
        '''''Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        '''''
        '''''</param>
        '''''<param name="Action">
        '''''
        '''''
        ''''' action
        '''''ViInt32
        '''''Specifies how to use the calibration values from this session as the session is closed. 
        '''''<p>Defined Values:
        '''''          NIDCPOWER_VAL_COMMITThe new calibration constants are stored in the EEPROM.
        '''''          NIDCPOWER_VAL_CANCEL The old calibration constants are kept, and the new ones are discarded. 
        '''''
        '''''Default Value: NIDCPOWER_VAL_CANCEL
        '''''
        '''''</param>
        Public Function CloseExtCal(ByVal Action As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.CloseExtCal(Me._handle, Action)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        ''''' niDCPower_CalAdjustVoltageLevel
        '''''
        '''''
        ''''' ViStatus niDCPower_CalAdjustVoltageLevel (ViSession vi,
        '''''                                                ViConstString channelName,
        '''''												ViReal64 range,
        '''''                                                ViUInt32 numberOfMeasurements,
        '''''                                                ViReal64 requestedOutputs[],
        '''''                                                ViReal64 measuredOutputs[]);
        ''''' Purpose
        '''''Calculates the calibration constants for the voltage level for the specified output channel. This function compares the array in
        '''''      requestedOutputs to the array in measuredOutputs and calculates the
        '''''      calibration constants for the voltage level of the output channel. Refer to the calibration procedure
        '''''      of the device you are calibrating for detailed instructions on the
        '''''      appropriate use of this function. This function can only be called in an
        '''''      external calibration session.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''
        ''''' vi
        '''''ViSession
        '''''Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies the output channel to which these calibration settings apply.
        '''''
        '''''</param>
        '''''<param name="Range">
        '''''
        '''''
        ''''' range
        '''''ViReal64
        '''''Specifies the range to calibrate with these settings.  Only one channel at a time may be calibrated.
        '''''
        '''''</param>
        '''''<param name="Number_Of_Measurements">
        '''''
        '''''
        ''''' numberOfMeasurements
        '''''ViUInt32
        '''''Specifies the number of elements in requestedOutputs and measuredOutputs.
        '''''
        '''''</param>
        '''''<param name="Requested_Outputs">
        '''''
        '''''
        ''''' requestedOutputs
        '''''ViReal64[]
        '''''Specifies an array of the output values requested in the niDCPower_ConfigureVoltageLevel function.
        '''''
        '''''</param>
        '''''<param name="Measured_Outputs">
        '''''
        '''''
        ''''' measuredOutputs
        '''''ViReal64[]
        '''''Specifies an array of the output values measured by an external precision digital multimeter.
        '''''
        '''''</param>
        Public Function CalAdjustVoltageLevel(ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As UInteger, ByVal Requested_Outputs() As Double, ByVal Measured_Outputs() As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.CalAdjustVoltageLevel(Me._handle, Channel_Name, Range, Number_Of_Measurements, Requested_Outputs, Measured_Outputs)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_CalAdjustVoltageMeasurement
        '''''
        '''''
        ''''' ViStatus niDCPower_CalAdjustVoltageMeasurement
        '''''                   (ViSession vi, ViConstString channelName, ViReal64 range,
        '''''                    ViUInt32 numberOfMeasurements, ViReal64 reportedOutputs[],
        '''''                    ViReal64 measuredOutputs[]);
        ''''' Purpose
        '''''Calculates the calibration constants for the voltage measurements returned by the niDCPower_Measure
        ''''' function for the specified output channel. This function compares the array in reportedOutputs to the array in measuredOutputs
        ''''' and calculates the calibration constants for the voltage measurements returned by the niDCPower_Measure function.
        ''''' Refer to the calibration procedure for the device you are calibrating for detailed instructions on the appropriate 
        ''''' use of this function. This function can only be called in an external calibration session.
        ''''' 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''
        ''''' vi
        '''''ViSession
        '''''Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies the channel name to which these calibration settings apply.
        '''''
        '''''</param>
        '''''<param name="Range">
        '''''
        '''''</param>
        '''''<param name="Number_Of_Measurements">
        '''''
        '''''
        ''''' numberOfMeasurements
        '''''ViUInt32
        '''''Specifies the number of elements in reportedOutputs and measuredOutputs.
        '''''
        '''''</param>
        '''''<param name="Reported_Outputs">
        '''''
        '''''
        ''''' reportedOutputs
        '''''ViReal64[]
        '''''Specifies an array of the output values that were returned by the niDCPower_Measure function.
        '''''
        '''''</param>
        '''''<param name="Measured_Outputs">
        '''''
        '''''
        ''''' measuredOutputs
        '''''ViReal64[]
        '''''Specifies an array of the output values measured by an external precision digital multimeter.
        '''''
        '''''</param>
        Public Function CalAdjustVoltageMeasurement(ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As UInteger, ByVal Reported_Outputs() As Double, ByVal Measured_Outputs() As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.CalAdjustVoltageMeasurement(Me._handle, Channel_Name, Range, Number_Of_Measurements, Reported_Outputs, Measured_Outputs)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_CalAdjustCurrentLimit
        '''''
        '''''
        ''''' ViStatus niDCPower_CalAdjustCurrentLimit (ViSession vi,
        '''''                                                ViConstString channelName,
        '''''                                                ViReal64 range,
        '''''                                                ViUInt32 numberOfMeasurements,
        '''''                                                ViReal64 requestedOutputs[],
        '''''                                                ViReal64 measuredOutputs[]);
        ''''' Purpose
        '''''Calculates the calibration constants for the current limit for the specified output channel and range. This function compares the array in requestedOutputs 
        '''''to the array in measuredOutputs and calculates the calibration constants for the current limit returned by the device. Refer to the calibration procedure for the power 
        '''''supply you are calibrating for detailed instructions on the appropriate use of this function. This function can only be called from an external calibration session.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies the channel name to which these calibration settings apply.
        '''''
        '''''</param>
        '''''<param name="Range">
        '''''
        '''''</param>
        '''''<param name="Number_Of_Measurements">
        '''''
        '''''
        ''''' numberOfMeasurements
        '''''ViUInt32
        '''''Specifies the number of elements in requestedOutputs and measuredOutputs.
        '''''
        '''''</param>
        '''''<param name="Requested_Outputs">
        '''''
        '''''
        ''''' requestedOutputs
        '''''ViReal64[]
        '''''Specifies an array of the output values that were requested in the niDCPower_ConfigureCurrentLimit function.
        '''''
        '''''</param>
        '''''<param name="Measured_Outputs">
        '''''
        '''''
        ''''' measuredOutputs
        '''''ViReal64[]
        '''''Specifies an array of the output values measured by an external precision digital multimeter.
        '''''
        '''''</param>
        Public Function CalAdjustCurrentLimit(ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As UInteger, ByVal Requested_Outputs() As Double, ByVal Measured_Outputs() As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.CalAdjustCurrentLimit(Me._handle, Channel_Name, Range, Number_Of_Measurements, Requested_Outputs, Measured_Outputs)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_CalAdjustCurrentMeasurement
        '''''
        '''''
        ''''' ViStatus niDCPower_CalAdjustCurrentMeasurement
        '''''                   (ViSession vi, ViConstString channelName,
        '''''                    ViReal64 range, ViUInt32 numberOfMeasurements,
        '''''                    ViReal64 reportedOutputs[], ViReal64 measuredOutputs[]);
        ''''' Purpose
        '''''Calibrates the current measurements returned by the niDCPower_Measure function for the specified output channel. This function calculates the 
        '''''calibration constants for the array in reportedOutputs to the array in measuredOutputs and calculates the calibration constants for the current 
        '''''measurements returned by the niDCPower_Measure function. Refer to the calibration procedure for the device you are calibrating for detailed instructions 
        '''''about the appropriate use of this function. This function can only be called in an external calibration session.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''
        ''''' vi
        '''''ViSession
        '''''Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies the output channel name to which these calibration settings apply.
        '''''
        '''''</param>
        '''''<param name="Range">
        '''''
        '''''</param>
        '''''<param name="Number_Of_Measurements">
        '''''
        '''''
        ''''' numberOfMeasurements
        '''''ViUInt32
        '''''Specifies the number of elements in reportedOutputs and measuredOutputs.
        '''''
        '''''</param>
        '''''<param name="Reported_Outputs">
        '''''
        '''''
        '''''reportedOutputs
        '''''ViReal64[]
        '''''Specifies an array of the output values that were returned by the niDCPower_Measure function.
        '''''
        '''''</param>
        '''''<param name="Measured_Outputs">
        '''''
        '''''
        '''''measuredOutputs
        '''''ViReal64[]
        '''''Specifies an array of the output values measured by an external precision digital multimeter.
        '''''
        '''''</param>
        Public Function CalAdjustCurrentMeasurement(ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As UInteger, ByVal Reported_Outputs() As Double, ByVal Measured_Outputs() As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.CalAdjustCurrentMeasurement(Me._handle, Channel_Name, Range, Number_Of_Measurements, Reported_Outputs, Measured_Outputs)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ChangeExtCalPassword
        '''''
        '''''
        ''''' ViStatus niDCPower_ChangeExtCalPassword (ViSession vi,
        '''''                                               ViConstString oldPassword,
        '''''                                               ViConstString newPassword);
        ''''' Purpose
        '''''Changes the password that is required to initialize an external calibration session. The password can be a maximum of four alphanumeric characters. If you call this function in a regular session, password is changed immediately. If you call this function in an external calibration session, password is changed only after you close the session using the niDCPower_CloseExtCal function with action set to NIDCPOWER_VAL_COMMIT.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''
        ''''' vi
        '''''ViSession
        '''''Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        '''''
        '''''</param>
        '''''<param name="Old_Password">
        '''''
        '''''
        ''''' oldPassword
        '''''ViConstString
        '''''Specifies the previous password used to protect the calibration values.
        '''''
        '''''</param>
        '''''<param name="New_Password">
        '''''
        '''''
        ''''' newPassword
        '''''ViConstString
        '''''Specifies the new password to use to protect the calibration values.
        '''''
        '''''</param>
        Public Function ChangeExtCalPassword(ByVal Old_Password As String, ByVal New_Password As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ChangeExtCalPassword(Me._handle, Old_Password, New_Password)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_GetExtCalRecommendedInterval
        '''''
        '''''
        ''''' ViStatus niDCPower_GetExtCalRecommendedInterval
        '''''                   (ViSession vi, ViInt32 *months);
        ''''' Purpose
        '''''Returns the recommended maximum interval, in months, between external calibrations.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''
        ''''' vi
        '''''ViSession
        '''''Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        '''''
        '''''</param>
        '''''<param name="Months">
        '''''
        '''''
        ''''' months
        '''''ViInt32*
        '''''Specifies the recommended maximum interval, in months, between external calibrations in months.
        '''''
        '''''</param>
        Public Function GetExtCalRecommendedInterval(ByRef Months As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetExtCalRecommendedInterval(Me._handle, Months)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_GetExtCalLastDateAndTime
        '''''
        '''''
        ''''' ViStatus niDCPower_GetExtCalLastDateAndTime (ViSession vi,
        '''''                                                   ViInt32 *year,
        '''''                                                   ViInt32 *month,
        '''''                                                   ViInt32 *day,
        '''''                                                   ViInt32 *hour,
        '''''                                                   ViInt32 *minute);
        ''''' Purpose
        '''''Returns the date and time of the last successful calibration. The time returned is 24-hour (military) local time; for example, if the device was calibrated at 2:30 PM, this function returns 14 for hours and 30 for minutes.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''
        ''''' vi
        '''''ViSession
        '''''Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        '''''
        '''''</param>
        '''''<param name="Year">
        '''''
        '''''
        ''''' year
        '''''ViInt32*
        '''''Returns the year the device was last calibrated.
        '''''
        '''''</param>
        '''''<param name="Month">
        '''''
        '''''
        ''''' month
        '''''ViInt32*
        '''''Returns the month in which the device was last calibrated.
        '''''
        '''''</param>
        '''''<param name="Day">
        '''''
        '''''
        ''''' day
        '''''ViInt32*
        '''''Returns the day on which the device was last calibrated.
        '''''
        '''''</param>
        '''''<param name="Hour">
        '''''
        '''''
        ''''' hour
        '''''ViInt32*
        '''''Returns the hour (in 24-hour time) in which the device was last calibrated.
        '''''
        '''''</param>
        '''''<param name="Minute">
        '''''
        '''''
        ''''' minute
        '''''ViInt32*
        '''''Returns the minute in which the device was last calibrated.
        '''''
        '''''</param>
        Public Function GetExtCalLastDateAndTime(ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetExtCalLastDateAndTime(Me._handle, Year, Month, Day, Hour, Minute)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_GetCalUserDefinedInfoMaxSize
        '''''
        '''''
        ''''' ViStatus niDCPower_GetCalUserDefinedInfoMaxSize
        '''''                   (ViSession vi, ViInt32*infoSize);
        ''''' Purpose
        '''''Returns the maximum number of characters that can be used to store user-defined information in the device onboard EEPROM.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''
        ''''' vi
        '''''ViSession
        '''''Identifies a particular instrument session. vi is obtained from 
        '''''the niDCPower_init or 
        '''''the niDCPower_InitWithOptions 
        '''''function.
        '''''
        '''''</param>
        '''''<param name="Info_Size">
        '''''
        '''''
        ''''' infoSize
        '''''ViInt32*
        '''''Returns the number of characters that can be stored in the device onboard EEPROM.
        '''''
        '''''</param>
        Public Function GetCalUserDefinedInfoMaxSize(ByRef Info_Size As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetCalUserDefinedInfoMaxSize(Me._handle, Info_Size)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_SetCalUserDefinedInfo
        '''''
        '''''
        ''''' ViStatus niDCPower_SetCalUserDefinedInfo (ViSession vi,
        '''''                                                ViConstString info);
        ''''' Purpose
        '''''Stores a user-defined string of characters in the device onboard EEPROM. If the string is longer than the maximum allowable size, it is truncated. This function overwrites any existing user-defined information.<p>If you call this function in a regular session, info is immediately changed. If you call this function in an external calibration session, info is changed only after you close the session using the niDCPower_CloseExtCal function with action set to NIDCPOWER_VAL_COMMIT.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Info">
        '''''
        ''''' info
        '''''ViConstString
        '''''Specifies the string to store in the device onboard EEPROM.</table>
        '''''
        '''''</param>
        Public Function SetCalUserDefinedInfo(ByVal Info As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.SetCalUserDefinedInfo(Me._handle, Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_GetCalUserDefinedInfo
        '''''
        '''''
        ''''' ViStatus niDCPower_GetCalUserDefinedInfo (ViSession vi,
        '''''                                                ViString info);
        ''''' Purpose
        '''''Returns the user-defined information in the device onboard EEPROM.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''
        ''''' vi
        '''''ViSession
        '''''Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        '''''
        '''''</param>
        '''''<param name="Info">
        '''''
        '''''
        ''''' info
        '''''ViString
        '''''Returns the user-defined information stored in the device onboard EEPROM.
        '''''
        '''''</param>
        Public Function GetCalUserDefinedInfo(ByVal Info As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetCalUserDefinedInfo(Me._handle, Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_ReadCurrentTemperature
        '''''
        '''''
        ''''' ViStatus niDCPower_ReadCurrentTemperature (ViSession vi,
        '''''                                                 ViReal64 *temperature);
        ''''' Purpose
        '''''Returns the current onboard temperature, in degrees Celsius, of the device.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Temperature">
        '''''
        ''''' temperature
        '''''ViReal64*
        '''''Returns the onboard temperature, in degrees Celsius, of the device.</table>
        '''''
        '''''</param>
        Public Function ReadCurrentTemperature(ByRef Temperature As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadCurrentTemperature(Me._handle, Temperature)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_GetExtCalLastTemp
        '''''
        '''''
        ''''' ViStatus niDCPower_GetExtCalLastTemp (ViSession vi,
        '''''                                            ViReal64 *temperature);
        ''''' Purpose
        '''''Returns the onboard temperature of the device, in degrees Celsius, during the last successful external calibration.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''
        ''''' vi
        '''''ViSession
        '''''Identifies a particular instrument calibration session. vi is obtained from the niDCPower_InitExtCal function.
        '''''
        '''''</param>
        '''''<param name="Temperature">
        '''''
        '''''
        ''''' temperature
        '''''ViReal64*
        '''''Returns the onboard temperature of the device, in degrees Celsius, during the last successful external calibration.
        '''''
        '''''</param>
        Public Function GetExtCalLastTemp(ByRef Temperature As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetExtCalLastTemp(Me._handle, Temperature)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_Disable
        '''''
        '''''
        ''''' ViStatus niDCPower_Disable (ViSession vi);
        ''''' Purpose
        '''''Places the device in a quiescent state where it has minimal or no impact on the system to which it is connected. The power output and all exported signals are disabled. This function performs the same actions as the niDCPower_reset function.  
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        Public Function Disable() As Integer
            Dim pInvokeResult As Integer = PInvoke.Disable(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_reset
        '''''
        '''''
        ''''' ViStatus niDCPower_reset (ViSession vi);
        ''''' Purpose
        '''''Resets the device to a known state.  This function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in  Immediate mode.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        Public Function reset() As Integer
            Dim pInvokeResult As Integer = PInvoke.reset(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_ResetDevice
        '''''
        '''''
        ''''' ViStatus niDCPower_ResetDevice (ViSession vi);
        ''''' Purpose
        '''''Resets the device to a known state.  The function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in  Immediate mode.
        '''''The niDCPower_ResetDevice function performs a hard reset on the device and the driver software. This function has the same functionality as using reset in Measurement &amp; Automation Explorer.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        Public Function ResetDevice() As Integer
            Dim pInvokeResult As Integer = PInvoke.ResetDevice(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_self_test
        '''''
        '''''
        ''''' ViStatus niDCPower_self_test (ViSession vi,
        '''''                                    ViInt16 *selfTestResult,
        '''''                                    ViChar selfTestMessage[]);
        ''''' Purpose
        '''''Performs the device self-test routine and returns the test result(s). Calling this function implicitly calls the niDCPower_reset function.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Self_Test_Result">
        '''''
        ''''' selfTestResult
        '''''ViInt16*
        '''''Returns the value result from the device self-test.
        '''''
        '''''
        '''''Self-Test CodeDescription0Self test passed.
        '''''1Self test failed.
        '''''</table>
        '''''</param>
        '''''<param name="Self_Test_Message">
        '''''
        ''''' selfTestMessage
        '''''ViChar[]
        '''''Returns the self-test result message. The size of this array must be at least 256 bytes.</table>
        '''''
        '''''</param>
        Public Function self_test(ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.self_test(Me._handle, Self_Test_Result, Self_Test_Message)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_revision_query
        '''''
        '''''
        ''''' ViStatus niDCPower_revision_query (ViSession vi,
        '''''                                         ViChar instrumentDriverRevision[],
        '''''                                         ViChar firmwareRevision[]);
        ''''' Purpose
        '''''Returns the revision information of NI-DCPower and the device firmware.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Instrument_Driver_Revision">
        '''''
        ''''' instrumentDriverRevision
        '''''ViChar[]
        '''''Returns the driver revision information for NI-DCPower.</table>
        '''''
        '''''</param>
        '''''<param name="Firmware_Revision">
        '''''
        ''''' firmwareRevision
        '''''ViChar[]
        '''''Returns firmware revision information for the device you are using. The size of this array must be at least 256 bytes.</table>
        '''''
        '''''</param>
        Public Function revision_query(ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.revision_query(Me._handle, Instrument_Driver_Revision, Firmware_Revision)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_ResetWithDefaults
        '''''
        '''''
        ''''' ViStatus niDCPower_ResetWithDefaults (ViSession vi);
        ''''' Purpose
        '''''Resets the device to a known state. This function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in  Immediate mode. In addition to exhibiting the behavior of the niDCPower_reset function, this function can assign user-defined default values for configurable attributes from the IVI configuration.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        Public Function ResetWithDefaults() As Integer
            Dim pInvokeResult As Integer = PInvoke.ResetWithDefaults(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_GetChannelName
        '''''
        '''''  ViStatus niDCPower_GetChannelName (ViSession vi,
        '''''                                         ViInt32 index, ViInt32 bufferSize,
        '''''                                         ViChar channelName[]);
        ''''' Purpose
        '''''Retrieves the output channelName that corresponds to the requested index. Use the 
        '''''NIDCPOWER_ATTR_CHANNEL_COUNT
        ''''' attribute to determine the upper bound of valid values for index.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Index">
        '''''
        '''''
        ''''' index
        '''''ViInt32
        '''''Specifies which output channel name to return. The index values begin at 1.
        '''''
        '''''</table>
        '''''
        '''''</param>
        '''''<param name="Buffer_Size">
        '''''
        '''''
        ''''' bufferSize
        '''''ViInt32
        '''''Specifies the number of bytes in the ViChar array you specify for channelName. If the channelName, including the terminating NUL byte, contains more bytes than you indicate in this attribute, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is 123456 and the buffer size is 4, the function places 123 into the buffer and returns 7.
        '''''
        '''''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        '''''
        '''''If you pass 0, you can pass VI_NULL for channelName.</table>
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        '''''
        ''''' channelName
        '''''ViChar[]
        '''''Returns the output channel name that corresponds to index.</table>
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''
        ''''' StatusViStatusReports the status of this operation. To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.
        '''''
        '''''</returns>
        Public Function GetChannelName(ByVal Index As Integer, ByVal Buffer_Size As Integer, ByVal Channel_Name As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetChannelName(Me._handle, Index, Buffer_Size, Channel_Name)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_GetNextCoercionRecord
        '''''
        ''''' ViStatus niDCPower_GetNextCoercionRecord (ViSession vi,
        '''''                                                ViInt32 bufferSize,
        '''''                                                ViChar coercionRecord[]);
        ''''' Purpose
        '''''Returns the coercion information associated with the IVI session and clears the earliest instance in which NI-DCPower coerced a value you specified.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Buffer_Size">
        '''''
        '''''
        ''''' bufferSize
        '''''ViInt32
        '''''Specifies the number of bytes in the ViChar array you specify for coercionRecord. If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this attribute, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is 123456 and the buffer size is 4, the function places 123 into the buffer and returns 7.
        '''''
        '''''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        '''''
        '''''If you pass 0, you can pass VI_NULL for coercionRecord.</table>
        '''''
        '''''</param>
        '''''<param name="Coercion_Record">
        '''''
        '''''
        ''''' coercionRecord
        '''''ViChar[]
        '''''Returns the next coercionRecord for the IVI session. If there are no coercionRecords, the function returns an empty string.</table>
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''
        ''''' StatusViStatusReports the status of this operation. To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.
        '''''
        '''''</returns>
        Public Function GetNextCoercionRecord(ByVal Buffer_Size As Integer, ByVal Coercion_Record As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetNextCoercionRecord(Me._handle, Buffer_Size, Coercion_Record)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_ClearInterchangeWarnings
        '''''
        '''''
        ''''' ViStatus niDCPower_ClearInterchangeWarnings
        '''''                   (ViSession vi);
        ''''' Purpose
        '''''Clears the list of current interchange warnings.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        Public Function ClearInterchangeWarnings() As Integer
            Dim pInvokeResult As Integer = PInvoke.ClearInterchangeWarnings(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''niDCPower_ResetInterchangeCheck
        '''''
        '''''
        ''''' ViStatus niDCPower_ResetInterchangeCheck (ViSession vi);
        ''''' Purpose
        '''''When developing a complex test system that consists of multiple test
        '''''      modules, it is generally a good idea to design the test modules so that
        '''''      they can run in any order.  To do so requires ensuring that each test
        '''''      module completely configures the state of each instrument it uses.  If a
        '''''      particular test module does not completely configure the state of an
        '''''      instrument, the state of the instrument depends on the configuration from
        '''''      a previously executed test module.  If you execute the test modules in a
        '''''      different order, the behavior of the instrument and therefore the entire
        '''''      test module is likely to change.  This change in behavior is generally
        '''''      instrument specific and represents an interchangeability problem.
        '''''	  You can use this function to test for such cases.  After you call this
        '''''      function, the interchangeability checking algorithms in the specific
        '''''      driver ignore all previous configuration operations.  By calling this
        '''''      function at the beginning of a test module, you can determine whether the
        '''''      test module has dependencies on the operation of previously executed test
        '''''      modules.<p>This function does not clear the interchangeability warnings from the
        '''''      list of previously recorded interchangeability warnings.  If you want to
        '''''      guarantee that the niDCPower_GetNextInterchangeWarning function only
        '''''      returns those interchangeability warnings that are generated after
        '''''      calling this function, you must clear the list of interchangeability
        '''''      warnings.  You can clear the interchangeability warnings list by
        '''''      repeatedly calling the niDCPower_GetNextInterchangeWarning function until
        '''''      no more interchangeability warnings are returned.  If you are not
        '''''      interested in the content of those warnings, you can call the
        '''''      niDCPower_ClearInterchangeWarnings function.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        Public Function ResetInterchangeCheck() As Integer
            Dim pInvokeResult As Integer = PInvoke.ResetInterchangeCheck(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''
        '''''
        '''''niDCPower_GetNextInterchangeWarning
        '''''
        '''''
        ''''' ViStatus niDCPower_GetNextInterchangeWarning (ViSession vi,
        '''''                                                    ViInt32 bufferSize,
        '''''                                                    ViChar interchangeWarning[]);
        ''''' Purpose
        '''''This function returns the interchangeability warning associated with the IVI session. It retrieves and clears the earliest instance in which the class driver recorded an interchangeability warning. Interchangeability warnings indicate that using your application with a different device may cause a different behavior. 
        '''''NI-DCPower performs interchangeability checking when the NIDCPOWER_ATTR_INTERCHANGE_CHECK attribute is set to VI_TRUE. This function returns an empty string in warning if no interchangeability warnings remain for the session. In general, NI-DCPower generates interchangeability warnings when an attribute that affects the behavior of the device is in a state that you did not specify.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Buffer_Size">
        '''''
        '''''
        ''''' bufferSize
        '''''ViInt32
        '''''Specifies the number of bytes in the ViChar array you specify for interchangeWarning. If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate in this attribute, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is 123456 and the buffer size is 4, the function places 123 into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        '''''
        '''''If you pass 0, you can pass VI_NULL for interchangeWarning.</table>
        '''''
        '''''</param>
        '''''<param name="Interchange_Warning">
        ''''' 
        '''''
        ''''' interchangeWarning
        '''''ViChar[]
        '''''Returns the next interchange warning for the IVI session. If there are no interchange warnings, the function returns an empty string.</table>
        '''''
        '''''</param>
        '''''<returns>
        '''''
        '''''
        ''''' StatusViStatusReports the status of this operation. To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.
        '''''
        '''''</returns>
        Public Function GetNextInterchangeWarning(ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetNextInterchangeWarning(Me._handle, Buffer_Size, Interchange_Warning)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Obsolete
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''
        '''''</param>
        '''''<param name="Channel_Name">
        '''''
        ''''' channelName
        '''''ViConstString
        '''''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence 
        '''''of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). In  Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
        '''''
        '''''</param>
        '''''<param name="Range_Type">
        '''''
        '''''</param>
        '''''<param name="Range">
        '''''
        '''''
        ''''' range
        '''''ViReal64
        '''''Specifies the voltage level range, in volts, on the specified channel(s).
        '''''
        '''''
        '''''
        '''''
        '''''
        '''''Valid Values:
        '''''
        '''''
        '''''NI PXI-4110
        '''''ChannelVoltage Level Range (V)Voltage Level (V)
        '''''060 to +6
        '''''1200 to +20
        '''''2200 to -20
        '''''
        '''''
        '''''NI PXI-4130
        '''''
        '''''ChannelVoltage Level Range (V)Voltage Level (V)
        '''''060 to +6
        '''''16-6 to +6
        '''''20-20 to +20
        '''''
        '''''Note&#160;&#160;  If a range other than what is listed in the preceding table is selected, it will be coerced to the next-highest range.  For example, requesting the 10 V voltage level range on Channel 1 on the NI-PXI 4130 coerces the voltage level range to 20 V.  Refer to the Ranges topic in the NI DC Power Supplies and SMUs Help for more information about coercion.
        '''''
        '''''
        '''''
        '''''
        '''''</param>
        Public Function ConfigureOutputRange(ByVal Channel_Name As String, ByVal Range_Type As Integer, ByVal Range As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureOutputRange(Me._handle, Channel_Name, Range_Type, Range)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
            Me.Dispose(True)
            System.GC.SuppressFinalize(Me)
        End Sub

        Private Overloads Sub Dispose(ByVal disposing As Boolean)
            If (Me._disposed = False) Then
                PInvoke.close(Me._handle)
                Me._handle = System.IntPtr.Zero
            End If
            Me._disposed = True
        End Sub

        Protected Overrides Sub Finalize()
            Me.Dispose(False)
        End Sub

        Public Overloads Sub SetInt32(ByVal propertyId As nidcpowerProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Integer)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetInt32(ByVal propertyId As nidcpowerProperties, ByVal val As Integer)
            Me.SetInt32(propertyId, "", val)
        End Sub

        Public Overloads Function GetInt32(ByVal propertyId As nidcpowerProperties, ByVal repeatedCapabilityOrChannel As String) As Integer
            Dim val As Integer
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return val
        End Function

        Public Overloads Function GetInt32(ByVal propertyId As nidcpowerProperties) As Integer
            Return Me.GetInt32(propertyId, "")
        End Function

        Public Overloads Sub SetDouble(ByVal propertyId As nidcpowerProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Double)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetDouble(ByVal propertyId As nidcpowerProperties, ByVal val As Double)
            Me.SetDouble(propertyId, "", val)
        End Sub

        Public Overloads Function GetDouble(ByVal propertyId As nidcpowerProperties, ByVal repeatedCapabilityOrChannel As String) As Double
            Dim val As Double
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return val
        End Function

        Public Overloads Function GetDouble(ByVal propertyId As nidcpowerProperties) As Double
            Return Me.GetDouble(propertyId, "")
        End Function

        Public Overloads Sub SetBoolean(ByVal propertyId As nidcpowerProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Boolean)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), System.Convert.ToUInt16(val)))
        End Sub

        Public Overloads Sub SetBoolean(ByVal propertyId As nidcpowerProperties, ByVal val As Boolean)
            Me.SetBoolean(propertyId, "", val)
        End Sub

        Public Overloads Function GetBoolean(ByVal propertyId As nidcpowerProperties, ByVal repeatedCapabilityOrChannel As String) As Boolean
            Dim val As UShort
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return System.Convert.ToBoolean(val)
        End Function

        Public Overloads Function GetBoolean(ByVal propertyId As nidcpowerProperties) As Boolean
            Return Me.GetBoolean(propertyId, "")
        End Function

        Public Overloads Sub SetString(ByVal propertyId As nidcpowerProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As String)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetString(ByVal propertyId As nidcpowerProperties, ByVal val As String)
            Me.SetString(propertyId, "", val)
        End Sub

        Public Overloads Function GetString(ByVal propertyId As nidcpowerProperties, ByVal repeatedCapabilityOrChannel As String) As String
            Dim newVal As System.Text.StringBuilder = New System.Text.StringBuilder(512)
            Dim size As Integer = PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), 512, newVal)
            If (size < 0) Then
                PInvoke.ThrowError(Me._handle, size)
            Else
                If (size > 0) Then
                    newVal.Capacity = size
                    PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), size, newVal))
                End If
            End If
            Return newVal.ToString
        End Function

        Public Overloads Function GetString(ByVal propertyId As nidcpowerProperties) As String
            Return Me.GetString(propertyId, "")
        End Function

        Private Class PInvoke

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_init", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function init(ByVal Resource_Name As String, ByVal ID_Query As UShort, ByVal Reset_Device As UShort, ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_InitExtCal", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function InitExtCal(ByVal Resource_Name As String, ByVal Password As String, ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_InitWithOptions", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function InitWithOptions(ByVal Resource_Name As String, ByVal ID_Query As UShort, ByVal Reset_Device As UShort, ByVal Option_String As String, ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureOutputEnabled", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureOutputEnabled(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Enabled As UShort) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureOutputFunction", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureOutputFunction(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal [Function] As Integer) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_MeasureMultiple", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function MeasureMultiple(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, <[In](), Out()> ByVal Voltage_Measurements As Double(), <[In](), Out()> ByVal Current_Measurements As Double()) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureSense", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureSense(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Sense As Integer) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_Initiate", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Initiate(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_Abort", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Abort(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureVoltageLevel", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureVoltageLevel(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Level As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureVoltageLevelRange", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureVoltageLevelRange(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureCurrentLimit", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureCurrentLimit(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Behavior As Integer, ByVal Limit As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureCurrentLimitRange", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureCurrentLimitRange(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureCurrentLevel", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureCurrentLevel(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Level As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureCurrentLevelRange", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureCurrentLevelRange(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureVoltageLimit", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureVoltageLimit(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Limit As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureVoltageLimitRange", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureVoltageLimitRange(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_QueryOutputState", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function QueryOutputState(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Output_State As Integer, ByRef In_State As UShort) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_QueryInCompliance", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function QueryInCompliance(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByRef In_Compliance As UShort) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_Measure", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Measure(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Measurement_Type As Integer, ByRef Measurement As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_QueryMaxCurrentLimit", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function QueryMaxCurrentLimit(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Voltage_Level As Double, ByRef Max_Current_Limit As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_QueryMaxVoltageLevel", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function QueryMaxVoltageLevel(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Current_Limit As Double, ByRef Max_Voltage_Level As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_QueryMinCurrentLimit", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function QueryMinCurrentLimit(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Voltage_Level As Double, ByRef Min_Current_Limit As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_CloseExtCal", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function CloseExtCal(ByVal Instrument_Handle As System.IntPtr, ByVal Action As Integer) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_CalAdjustVoltageLevel", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function CalAdjustVoltageLevel(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As UInteger, ByVal Requested_Outputs As Double(), ByVal Measured_Outputs As Double()) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_CalAdjustVoltageMeasurement", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function CalAdjustVoltageMeasurement(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As UInteger, ByVal Reported_Outputs As Double(), ByVal Measured_Outputs As Double()) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_CalAdjustCurrentLimit", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function CalAdjustCurrentLimit(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As UInteger, ByVal Requested_Outputs As Double(), ByVal Measured_Outputs As Double()) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_CalAdjustCurrentMeasurement", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function CalAdjustCurrentMeasurement(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As UInteger, ByVal Reported_Outputs As Double(), ByVal Measured_Outputs As Double()) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ChangeExtCalPassword", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ChangeExtCalPassword(ByVal Instrument_Handle As System.IntPtr, ByVal Old_Password As String, ByVal New_Password As String) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetExtCalRecommendedInterval", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetExtCalRecommendedInterval(ByVal Instrument_Handle As System.IntPtr, ByRef Months As Integer) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetExtCalLastDateAndTime", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetExtCalLastDateAndTime(ByVal Instrument_Handle As System.IntPtr, ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetCalUserDefinedInfoMaxSize", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetCalUserDefinedInfoMaxSize(ByVal Instrument_Handle As System.IntPtr, ByRef Info_Size As Integer) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_SetCalUserDefinedInfo", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetCalUserDefinedInfo(ByVal Instrument_Handle As System.IntPtr, ByVal Info As String) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetCalUserDefinedInfo", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetCalUserDefinedInfo(ByVal Instrument_Handle As System.IntPtr, ByVal Info As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ReadCurrentTemperature", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ReadCurrentTemperature(ByVal Instrument_Handle As System.IntPtr, ByRef Temperature As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetExtCalLastTemp", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetExtCalLastTemp(ByVal Instrument_Handle As System.IntPtr, ByRef Temperature As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_Disable", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Disable(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_reset", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function reset(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ResetDevice", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ResetDevice(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_self_test", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function self_test(ByVal Instrument_Handle As System.IntPtr, ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_revision_query", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function revision_query(ByVal Instrument_Handle As System.IntPtr, ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ResetWithDefaults", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ResetWithDefaults(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetChannelName", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetChannelName(ByVal Instrument_Handle As System.IntPtr, ByVal Index As Integer, ByVal Buffer_Size As Integer, ByVal Channel_Name As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetNextCoercionRecord", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetNextCoercionRecord(ByVal Instrument_Handle As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Coercion_Record As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ClearInterchangeWarnings", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ClearInterchangeWarnings(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ResetInterchangeCheck", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ResetInterchangeCheck(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetNextInterchangeWarning", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetNextInterchangeWarning(ByVal Instrument_Handle As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureOutputRange", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureOutputRange(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range_Type As Integer, ByVal Range As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_close", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function close(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_error_message", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function error_message(ByVal Instrument_Handle As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Message_2 As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Integer) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Buffer_Size As Integer, ByVal Attribute_Value As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As UShort) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_SetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Integer) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_SetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Double) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_SetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As String) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_SetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As UShort) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_SetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.IntPtr) As Integer
            End Function

            <DllImport("niDCPower_32.dll", EntryPoint:="niDCPower_GetError", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetError(ByVal Instrument_Handle As System.IntPtr, ByRef Code As Integer, ByVal BufferSize As Integer, ByVal Description As System.Text.StringBuilder) As Integer
            End Function


            Public Shared Function TestForError(ByVal handle As System.IntPtr, ByVal status As Integer) As Integer
                If (status < 0) Then
                    PInvoke.ThrowError(handle, status)
                End If
                Return status
            End Function

            Public Shared Function ThrowError(ByVal handle As System.IntPtr, ByVal code As Integer) As Integer
                Dim status As Integer
                Dim size As Integer = PInvoke.GetError(handle, status, 0, Nothing)
                Dim msg As System.Text.StringBuilder = New System.Text.StringBuilder
                If (size >= 0) Then
                    msg.Capacity = size
                    PInvoke.GetError(handle, status, size, msg)
                End If
                Throw New System.Runtime.InteropServices.ExternalException(msg.ToString, code)
            End Function
        End Class
    End Class

    Public Class nidcpowerConstants

        Public Const DcVoltage As Integer = 1006

        Public Const DcCurrent As Integer = 1007

        Public Const Local As Integer = 1008

        Public Const Remote As Integer = 1009

        Public Const CurrentRegulate As Integer = 0

        Public Const OutputConstantVoltage As Integer = 0

        Public Const OutputConstantCurrent As Integer = 1

        Public Const MeasureVoltage As Integer = 1

        Public Const MeasureCurrent As Integer = 0

        Public Const Cancel As Integer = 1001

        Public Const Commit As Integer = 1002

        Public Const RangeVoltage As Integer = 1

        Public Const RangeCurrent As Integer = 0

        Public Const Off As Integer = 0

        Public Const [On] As Integer = 1

        Public Const Internal As Integer = 1003

        Public Const Auxiliary As Integer = 1004

        Public Const Automatic As Integer = 1005

        Public Const Low As Integer = 1010

        Public Const High As Integer = 1011
    End Class

    Public Enum nidcpowerProperties

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        OutputEnabled = 1250006

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        OutputFunction = 1150008

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        Sense = 1150013

        '''''<summary>
        '''''System.Double
        '''''</summary>
        VoltageLevel = 1250001

        '''''<summary>
        '''''System.Double
        '''''</summary>
        CurrentLimit = 1250005

        '''''<summary>
        '''''System.Double
        '''''</summary>
        VoltageLevelRange = 1150005

        '''''<summary>
        '''''System.Double
        '''''</summary>
        CurrentLimitRange = 1150004

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        VoltageLevelAutorange = 1150015

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        CurrentLimitAutorange = 1150016

        '''''<summary>
        '''''System.Double
        '''''</summary>
        CurrentLevel = 1150009

        '''''<summary>
        '''''System.Double
        '''''</summary>
        VoltageLimit = 1150010

        '''''<summary>
        '''''System.Double
        '''''</summary>
        CurrentLevelRange = 1150011

        '''''<summary>
        '''''System.Double
        '''''</summary>
        VoltageLimitRange = 1150012

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        CurrentLevelAutorange = 1150017

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        VoltageLimitAutorange = 1150018

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        PowerSource = 1150000

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        PowerSourceInUse = 1150001

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        AuxiliaryPowerSourceAvailable = 1150002

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        SamplesToAverage = 1150003

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        ResetAverageBeforeMeasurement = 1150006

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        OverrangingEnabled = 1150007

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        OutputCapacitance = 1150014

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        RangeCheck = 1050002

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        QueryInstrumentStatus = 1050003

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        Cache = 1050004

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        Simulate = 1050005

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        RecordCoercions = 1050006

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        InterchangeCheck = 1050021

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverDescription = 1050514

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverPrefix = 1050302

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverVendor = 1050513

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverRevision = 1050551

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        SpecificDriverClassSpecMajorVersion = 1050515

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        SpecificDriverClassSpecMinorVersion = 1050516

        '''''<summary>
        '''''System.String
        '''''</summary>
        SupportedInstrumentModels = 1050327

        '''''<summary>
        '''''System.String
        '''''</summary>
        GroupCapabilities = 1050401

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        ChannelCount = 1050203

        '''''<summary>
        '''''System.String
        '''''</summary>
        InstrumentManufacturer = 1050511

        '''''<summary>
        '''''System.String
        '''''</summary>
        InstrumentModel = 1050512

        '''''<summary>
        '''''System.String
        '''''</summary>
        InstrumentFirmwareRevision = 1050510

        '''''<summary>
        '''''System.String
        '''''</summary>
        LogicalName = 1050305

        '''''<summary>
        '''''System.String
        '''''</summary>
        IoResourceDescriptor = 1050304

        '''''<summary>
        '''''System.String
        '''''</summary>
        DriverSetup = 1050007
    End Enum
End Namespace
